/**
 * Created by tuchl on 2016-08-12.
 */

(function($) {
	$.init({
		swipeBack: true,
		swipe: true,
		beforeback:function(){
			plus.navigator.setFullscreen(false);
		}
	});
	var querySelector = function(selector) {
		return document.querySelector(selector)
	};
	var documentId; // 文章ID
	var articleContent; // 文章数据
	var oVideo = null; // 视频
	var collectionBtn = g("shoucang");

	var oComment = new Comment();
	var oPublish = new Publish(oComment);
	oComment.oPublish = oPublish;
	var oPraise = new Praise(oComment);

	/**
	 * 设置视频占位图片
	 */
	(function() {
		
		var imgUrl = common.utils.queryString('image');
		var videoCont = querySelector('.article-video-box');
		var clientWidth = document.documentElement.clientWidth;
		var iHeight = clientWidth * 9 / 16;
		videoCont.style.height = iHeight + 'px';
		$('.mui-content')[0].style.paddingTop = querySelector('.video-cont').offsetHeight + Number(app.imbarH + 44) + 'px';
		if(imgUrl){
			videoCont.innerHTML = '<img src="'+decodeURIComponent(imgUrl)+'" />';
		}
		documentId = common.utils.queryString('aid');
		initData(documentId);
		var styles = document.head.appendChild(document.createElement('style'));
		styles.type = 'text/css';
		styles.innerText = '.mui-bar~.mui-pull-top-tips{top:' + (iHeight + 44) + 'px}';
	})();
	
	/*收藏*/
	var collection = {
		initStates: function(states){
			if(states == 1) {
				collectionBtn.classList.add('c-cyan');
				collectionBtn.classList.add('jcon-collection-active');
				collectionBtn.colorchangge = true;
			} else {
				collectionBtn.colorchangge = false;
			}
		}
	};
	/*收藏*/
	collectionBtn.addEventListener('tap', function() {
		var shoucang = this;

		// 未登录
		if(!app.checkLogin()) {
			app.toLogin();
			return;
		}
		if(!this.colorchangge) {
			//1关注 
			newsSvc.collectionNews(documentId, '1').then(function() {
				mui.toast('收藏成功'); //提示内容
				shoucang.classList.add('c-cyan');
				shoucang.classList.add('jcon-collection-active');
				shoucang.colorchangge = true;
			});
		} else {
			//0取消关注
			newsSvc.collectionNews(documentId, '0').then(function() {
				mui.toast('取消收藏成功');
				shoucang.classList.remove('c-cyan');
				shoucang.classList.remove('jcon-collection-active');
				shoucang.colorchangge = false;
			});
		};
	});

	
	/**
	 * 初始化数据
	 * @param {Object} id
	 * @param {Object} isRefresh 是否刷新
	 */
	function initData(id, isRefresh) {
		newsSvc.documentContent(id).then(function(content) {
			
			if(!isRefresh) {
				playVideo(content);
				showContent(content);
				/* 是否隐藏评论  */
				if(!content.isHideReview) {
					querySelector('.comment-cont').removeAttribute('hidden');
					Pull.init(documentId, oComment.getInitCommentList.bind(oComment), {
						up: true,
						down: true
					});
				}
				shareVideo(content);
				oComment.listenDelete();
			}
			collection.initStates(content.isCollection);
			initRecommendList(content);
			/* 显示评论输入框 */
			oPublish.showCommentLayer(content);
			oPraise.init(content);
		}).catch(function(res) {
			querySelector('.comment-cont').removeAttribute('hidden');
			Pull.init(documentId, oComment.getInitCommentList.bind(oComment), {
				up: true,
				down: true
			});
			oComment.exceptionHandler(res);
		});
	}
	
	function getParentOffsetTop(dom) {
		var top = dom.offsetTop;
		var parent = dom.offsetParent;
		while(parent) {
			top += parent.offsetTop;
			parent = parent.offsetParent;
			if(!parent) {
				break;
			}
		}
		return top;
	}

	function playVideo(content){
		
		var shareMsg = {
			href:app._webUrl+"/article.html?id="+content.id,
			title:content.title,
			content:content.introduce,
			thumbs:[content.image],
			successCB:function(){
				newsSvc.setDocumentForwardAmount(content.id);
			}
		};
		try {
			joyPlayer.play({
	    		src:content.videoUrl,
	    		title:content.title,
	    		parent:document.querySelector('.article-video-box'),
	    		poster:content.image,
	    		shareMsg:shareMsg
			});	
		} catch (e) {
			console.log(e)
		}
	}
	function shareVideo(content) {
		var shareMsg = {
			href: app._webUrl + "/article.html?id=" + content.id,
			title: content.title,
			content: content.introduce
		};
		var oImgs = contentInfo.querySelectorAll('img');
		var pictures = [];
		var picNum = Math.min(oImgs.length, 9);
		for(var i = 0; i < picNum; i++) {
			pictures.push(oImgs[i].src);
		}
		if(content.image) {
			shareMsg.thumbs = [content.image];
		}
		shareMsg.pictures = pictures;
		share.initShare(g("share_button"), shareMsg, function() {
			$.toast('分享成功');
			newsSvc.setDocumentForwardAmount(content.id);
		}, function(e) {
			if(e.code === -100) {
				$.toast('已取消分享');
			} else {
				$.toast('分享失败：' + e.message);
			}
		});
		share.initShare(g("share_button2"), shareMsg, function() {
			$.toast('分享成功');
			newsSvc.setDocumentForwardAmount(content.id);
		}, function(e) {
			if(e.code === -100) {
				$.toast('已取消分享');
			} else {
				$.toast('分享失败：' + e.message);
			}
		});
	}
	function showVideoCover(content){
		var videoCont = querySelector('.article-video-box');
		if(!videoCont.querySelector('img')){
			var img = document.createElement('img');
			img.src = content.image;
			videoCont.appendChild(img);
		}
		var cover = document.createElement('div');
		cover.className='video-cover';
		cover.innerHTML='<span class="video-btn jcon jcon-play"></span>';
		cover.addEventListener('tap',function(){
			playVideo(content);
		},false);
		videoCont.appendChild(cover);
	}
	function showContent(content) {
		var author = document.querySelector('#author');
		author.innerHTML = common.utils.patternStrPlus(querySelector('#video-author').innerHTML, {
			authorName: content.authorName || '悦社',
			photoImg: content.authorHeadPath || '../images/user-photo.png',
			readNum: content.readAmount
		});
		g('articleTitle').innerHTML = content.title;
		g('releaseDate').innerHTML = content.releaseDate.substr(0, 10);
		showVideoCover(content);
		setTags(content);
	}
	function setTags(content) {
		var oTag = document.querySelector('.tag-box');
		var tags = content.keyWord && content.keyWord.split(/(,|，)/g).filter(function(val){if(',' != val&& '，'!=val)return val});
		
		Array.isArray(tags) && mui.each(tags, function(i, val){
			var oA = document.createElement('a');
			oA.setAttribute('href', 'javascript:;');
			oA.innerHTML = val;
			oTag.appendChild(oA);
			oA = null;
		})
		mui('.tag-box').on('tap', 'a', function(){
			var searchNews = plus.webview.getWebviewById('search_news');
			var words = this.innerText;
			plus.navigator.setFullscreen(false);
			(function(callback){
				if (searchNews) {
					searchNews.addEventListener('close',function(){
						callback();
					},false);
					searchNews.close('none');
	   			}else{
	   				callback();
	   			}
			})(function(){
				searchNews = app.openPage('search', {words: encodeURIComponent(words)});
			});
		})
	}
	function initRecommendList(content){
		var recommend = querySelector('.recommend-cont');
		var targetDom = document.querySelector('.re-body');
		var moreDom = recommend.querySelector('.re-more');
		newsSvc.docLikeRecommended(content.id, 5).then(function(res){
			var htmlResult = '';
			if (0 == res.length) return;
			recommend.classList.remove('mui-hidden');
			if (3 < res.length) {
				targetDom.style.height = '324px';
			} else {
				moreDom.style.display = 'none';
			}
			res.forEach(function(val){
				
				if (val.type == 1) {
					val.isVideo = 'hidden';
				}
				val.isHavReply = !val.replyCount ? 'hidden' : '';
				htmlResult += common.utils.patternStrPlus(querySelector('#recommend').innerHTML, val);
			})
			
			targetDom && (targetDom.innerHTML = htmlResult);
		}).catch(function(err){
		})
		
		$('.recommend').on('tap', '.video-li', function(){
			var aid = this.getAttribute('aid');
			var image = this.getAttribute('image');
			var videoUrl = this.getAttribute('videourl');
			var type = this.getAttribute('type');
			
			app.openPage( type == 1 ? 'article': 'video', {aid: aid, image: image, videoUrl: videoUrl})
			type == 1 && plus.navigator.setFullscreen(false);
			setTimeout(function(){
				var curView = plus.webview.currentWebview();
				curView.hide();
				curView.close();
			}, 1000)
		})
		
		var bBtn = false;
		$('.recommend').on('tap', '.re-more', function(e){
			bBtn = !bBtn;
			targetDom.style.height = bBtn ? 'auto' : '324px';
			
			if (bBtn) {
				moreDom.querySelector('.fa').classList.remove('fa-angle-down');
				moreDom.querySelector('.fa').classList.add('fa-angle-up');
			} else {
				moreDom.querySelector('.fa').classList.add('fa-angle-down');
				moreDom.querySelector('.fa').classList.remove('fa-angle-up');
			}
		})
	}
	var contScroll = $('.mui-scroll-wrapper').scroll({
		bounce: true
	});
	
	$.plusReady(function(){
		$.currentWebview.setStyle({
			softinputMode:"adjustResize"
		});	
		plus.navigator.setFullscreen(true);
	})
	window.addEventListener('refresh_data', function(e) { //执行刷新
		initData(documentId, true);
		joyPlayer.playing();
		oComment.getInitCommentList(documentId, 'down');
	});
	window.addEventListener('video-playing-listen', function(e) { //执行刷新
		joyPlayer.playing();
	});

	$(document).on('tap', '.go-comment-list', function() {
		var iTop = document.querySelector('.article_body').offsetHeight + document.querySelector('.recommend-cont').offsetHeight;
		contScroll.scrollTo(0, -iTop,0);
	});
	$('.extra-controll').on('tap', '.understand-more', function(){
		mui.fire(plus.webview.getLaunchWebview(), 'goTab', {tabid:'tab-joy'});	
		var allWebview = plus.webview.all();
		for (var i = 0; i < allWebview.length; i++) {
			if (plus.webview.getLaunchWebview().id != allWebview[i].id) {
				allWebview[i].close('none');
			}
		}
	});

	//var iTop = document.body.clientWidth * 9/16 + (imbar.isIphoneX ? 50 : 0);
	var iTop = g('author').offsetTop;
	// 显示评论的回复
	$('.comment-body').on('tap', '.reply-react', function(){
		var commentId = this.getAttribute('commentId');
		var replyId = this.getAttribute('replyId');
		oComment.showReplyList({artId: documentId, commentId: commentId, replyId: replyId}, true, iTop);
	});
	
	// 显示评论的回复
	$('.comment-body').on('tap', '.show-all span', function(){
		var commentId = this.getAttribute('commentId');
		oComment.showReplyList({artId: documentId, commentId: commentId}, false, iTop);
	});

})(mui);