/**
 * Created by tuchl on 2016-08-12.
 */
(function($) {
	var querySelector = function(selector) {
		return document.querySelector(selector)
	};
	var documentId; // 文章ID
	var articleContent; // 文章数据
	var contentInfo = g("contentInfo");

	var collectionBtn = g("shoucang");
	var shareBtn = g("share_button");

	var oComment = new Comment();
	var oPublish = new Publish(oComment);
	oComment.oPublish = oPublish;
	var oPraise = new Praise(oComment);

	(function() {
		documentId = common.utils.queryString('aid');
		initData(documentId);
	}());

	/*收藏*/
	var collection = {
		initStates: function(states){
			if(states == 1) {
				collectionBtn.classList.add('c-cyan');
				collectionBtn.classList.add('jcon-collection-active');
				collectionBtn.colorchangge = true;
			} else {
				collectionBtn.colorchangge = false;
			}
		}
	};
	/*收藏*/
	collectionBtn.addEventListener('tap', function() {
		var shoucang = this;

		// 未登录
		if(!app.checkLogin()) {
			app.toLogin();
			return;
		}
		if(!this.colorchangge) {
			//1关注 
			newsSvc.collectionNews(documentId, '1').then(function() {
				mui.toast('收藏成功'); //提示内容
				shoucang.classList.add('c-cyan');
				shoucang.classList.add('jcon-collection-active');
				shoucang.colorchangge = true;
			});
		} else {
			//0取消关注
			newsSvc.collectionNews(documentId, '0').then(function() {
				mui.toast('取消收藏成功');
				shoucang.classList.remove('c-cyan');
				shoucang.classList.remove('jcon-collection-active');
				shoucang.colorchangge = false;
			});
		};
	});


	// 夜间模式
	var screen = (function() {
		var screenBtn = querySelector('#read-mode');

		/**
		 * 设置阅读模式
		 * @param { Boolean } isChange （是否改变阅读模式）
		 */
		function setReadMode(isChange) {
			var defaultMode = myStorage.getItem('read');

			if(isChange) {
				defaultMode = !defaultMode;
				myStorage.setItem('read', defaultMode);
			}

			if(defaultMode) {
				querySelector('body').classList.add('night');

				screenBtn.classList.remove('jcon-moon-o');
				screenBtn.classList.add('jcon-sun');

			} else {
				querySelector('body').classList.remove('night');
				screenBtn.classList.remove('jcon-sun');
				screenBtn.classList.add('jcon-moon-o');
			}
		}
	}());

	var func = (function() {
		var screenBtn = g('read-mode');

		function theme(idx) {
			var bgs = ['#fff', '#080C10', '0,0,0', '0,0,0'];
			var cls = ['#262626', '#424952', '0,0,0', '0,0,0'];

		}

		function light(sw) {
			var defaultMode = myStorage.getItem('read');
			if(sw) {
				defaultMode = !defaultMode;
				myStorage.setItem('read', defaultMode);
			}
			if(defaultMode) {
				cover(0.5);
				screenBtn.classList.remove('jcon-moon-o');
				screenBtn.classList.add('jcon-sun');
			} else {
				jel('#lightCover').addClass('mui-hidden');
				screenBtn.classList.remove('jcon-sun');
				screenBtn.classList.add('jcon-moon-o');
			}
		}

		function cover(a, r, g, b) {
			var lightCover = document.getElementById('lightCover');
			if(!lightCover) {
				lightCover = document.createElement('div');
				lightCover.id = 'lightCover';
				lightCover.setAttribute('style', 'position:fixed;top:0;bottom:0;left:0;outline:4000px solid;z-index:99999;');
				document.body.appendChild(lightCover);
			} else {
				jel('#lightCover').removeClass('mui-hidden');
			}
			lightCover.style.outlineColor = 'rgba(' + (r || 0) + ',' + (g || 0) + ',' + (b || 0) + ',' + a + ')';
		}

		function setSize(size) {

		}

		screenBtn.addEventListener('tap', function() {
			light(true);
		}, false);

		light();

		return {
			light: cover,
			theme: theme,
			setSize: setSize
		};
	}());

	
	/**
	 * 初始化数据
	 * @param {Object} id
	 * @param {Object} isRefresh 是否刷新
	 */
	function initData(id, isRefresh) {
		newsSvc.documentContent(id).then(function(content) {
			
			if(!isRefresh) {
				setTitleView(content);
				g('loading').classList.add('ani-hidden');
				var shareMsg = {
					href: app._webUrl + "/article.html?id=" + id,
					title: content.title,
					content: content.introduce
				};
				var oImgs = contentInfo.querySelectorAll('img');
				var pictures = [];
				var picNum = Math.min(oImgs.length, 9);
				for(var i = 0; i < picNum; i++) {
					pictures.push(oImgs[i].src);
				}

				if(content.image) {
					shareMsg.thumbs = [content.image];
				}
				shareMsg.pictures = pictures;

				share.initShare(g('share_button'), shareMsg, function() {
					$.toast('分享成功');
					newsSvc.setDocumentForwardAmount(content.id);
				}, function(e) {
					if(e.code === -100) {
						$.toast('已取消分享');
					} else {
						$.toast('分享失败：' + e.message);
					}
				});
				share.initShare(g('share_button2'), shareMsg, function() {
					$.toast('分享成功');
					newsSvc.setDocumentForwardAmount(content.id);
				}, function(e) {
					if(e.code === -100) {
						$.toast('已取消分享');
					} else {
						$.toast('分享失败：' + e.message);
					}
				});

				jel('.article_content img').attr("data-preview-src", "");
				jel('.article_content img').attr("data-preview-group", "1");
				$.previewImage();

				/* 是否隐藏评论  */
				if(!content.isHideReview) {
					querySelector('.comment-cont').removeAttribute('hidden');
	           	 	Pull.init(documentId, oComment.getInitCommentList.bind(oComment), {up: true});
				}
				oComment.listenDelete();
				
				/* 显示评论 */
				oPublish.showCommentLayer(content);
			}
			collection.initStates(content.isCollection);
			oPraise.init(content);
			initRecommendList(content);
		}).catch(function(res) {
			g('loading').classList.add('ani-hidden');
		});
	}

	/**
	 * 设置标题
	 * @param {Object} content 文章相关信息
	 */
	function setTitleView(content) {
		var titView = querySelector('.mui-title');
		var html = '';
		var userPhoto;

		if(!content.authorName) {
			html = '<div id="aTitle"><img src="../images/joyshebao.png" />悦社</div>';
		} else {
			html = '<div id="aTitle"><img src="' + (content.authorHeadPath || '../images/user-photo.png') + '" />' + (content.authorName || '悦社') + '</div>';
		}
		titView.innerHTML = html;
		g('articleTitle').innerHTML = content.title;
		g('read-amount').innerHTML = content.readAmount + '次阅读';
		g('releaseDate').innerHTML = content.releaseDate.slice(0, -8);
		g('articleContent').innerHTML = content.content;
		setTags(content);
	}
	
	function setTags(content) {
		var oTag = document.querySelector('.tag-box');
		var tags = content.keyWord && content.keyWord.split(/(,|，)/g).filter(function(val){if(',' != val&& '，'!=val)return val});
		
		Array.isArray(tags) && mui.each(tags, function(i, val){
			var oA = document.createElement('a');
			oA.setAttribute('href', 'javascript:;');
			oA.innerHTML = val;
			oTag.appendChild(oA);
			oA = null;
		})
		
		mui('.tag-box').on('tap', 'a', function(){
			var searchNews = window.plus && plus.webview.getWebviewById('search_news');
			var words = this.innerText;
			var times = 0;
			
			if (searchNews) {
				searchNews.hide();
				searchNews.close();
				times = 200;
	   		} 
	   		setTimeout(function(){
	   			app.openPage('search', {words: encodeURIComponent(words)});
	   		}, times)
		})
	}
	function initRecommendList(content){
		var recommend = querySelector('.recommend-cont');
		
		newsSvc.docLikeRecommended(content.id).then(function(res){
			var htmlResult = '';
			if (0 == res.length) return;
			recommend.classList.remove('mui-hidden');
			res.forEach(function(val){
				if (val.type == 1) {
					val.isVideo = 'hidden';
				}
				htmlResult += common.utils.patternStrPlus(querySelector('#recommend').innerHTML, val);
			})
			var targetDom = document.querySelector('.recommend .mui-scroll');
			targetDom && (targetDom.innerHTML = htmlResult);	
		}).catch(function(err){})
		$('.recommend').on('tap', '.video-li', function(){
			var aid = this.getAttribute('aid');
			var image = this.getAttribute('image');
			var videoUrl = this.getAttribute('videourl');
			var type = this.getAttribute('type');
			app.openPage( type == 1 ? 'article': 'video', {aid: aid, image: image, videoUrl: videoUrl})
			setTimeout(function(){
				var curView = plus.webview.currentWebview();
				curView.hide();
				curView.close();
			}, 1000)

		})
		$('.mui-scroll-wrapper2').scroll({bounce: true,  scrollX: true});
		
		
		$('.recommend').on('tap', '.re-more', function(e){
			mui.back();
		})
	}
	
 	var contScroll = $('.mui-scroll-wrapper').scroll({bounce: true});

	$.plusReady(function() {
		$.currentWebview.setStyle({
			softinputMode:"adjustResize"
		});
		window.addEventListener('refresh_data', function(e) { //执行刷新
			initData(documentId, true);
			oComment.getInitCommentList(documentId, 'down');
		});

		$(document).on('tap', '.go-comment-list', function() {
			var iTop = document.querySelector('.article_body').offsetHeight + document.querySelector('.recommend-cont').offsetHeight;
			contScroll.scrollTo(0, -iTop);
		});
		$('.extra-controll').on('tap', '.understand-more', function(){
			mui.fire(plus.webview.getLaunchWebview(), 'goTab', {tabid:'tab-joy'});
			var allWebview = plus.webview.all();
			for (var i = 0; i < allWebview.length; i++) {
				if (plus.webview.getLaunchWebview().id != allWebview[i].id) {
					allWebview[i].close('none');
				}
			}
		});
	
		var iTop = imbar.getStatusbar().statusbarHeight + 44;
		// 显示评论的回复
		$('.comment-body').on('tap', '.reply-react', function(){
			var commentId = this.getAttribute('commentId');
			var replyId = this.getAttribute('replyId');
			oComment.showReplyList({commentId: commentId, replyId: replyId}, true,  iTop);
		})
		
		// 显示评论的回复
		$('.comment-body').on('tap', '.show-all span', function(){
			var commentId = this.getAttribute('commentId');
			oComment.showReplyList({commentId: commentId}, false, iTop);
		})

	});

})(mui);