/**
 * 拍照
 * date 2018-2-9
 */
Vue.component('dialog-camera', {
  
  template: '<div class="view-dialog" v-bind:class="{\'show\' : isShowCamera, \'hide\': !isShowCamera}">' +
			'<div class="v-cont select-options">' +
				'<ul>' +
					'<li class="b-border b-e8e9ec" v-tap="captrueImage">拍照</li>' +
					'<li class="b-border b-e8e9ec" v-tap="galleryImage">相册选择</li>' +
				'</ul>' +
				'<button v-tap="closeView">取消</button>' +
			'</div>' +
		'</div>',
  
  props: ['isShowCamera'],
  methods: {
    // 拍照
	captrueImage: function(){
		localFile.captureImage(this.uploadFile);
		this.closeView();
	},
	// 相册
	galleryImage: function(){
		localFile.galleryImage(this.uploadFile);
		this.closeView();
	},
	closeView: function(){
		this.$emit('close');
	},
	uploadFile: function(url){
		var wating = app.showWaiting('正在上传图片...');
		localFile.zipImage(url, zipHandler);
		
		// 图片上传
		function zipHandler(zipUrl){
			
			localFile.convertImageToBase64(zipUrl, function(base64){
				
				userSvc.modifyPortrait(base64).then(function(res){
					app.toast('设置头像成功');
					wating.close();	
					refreshUser(res);
				}).catch(function(res){
					wating.close();
				})
			});
		}
		
		function refreshUser(res){
			var userData = app.getUser();
			userData.headPath = res;
			app.createState(userData);
			// 通知其他页面用户信息有变动哦
			app.appRefresh();
		}
	}
  },
})