/**
 * 虚拟键盘
 * date 2018-1-18
 */
Vue.component('key-board', {
  // 有效，因为是在正确的作用域内
  template: '<div class="view-keyboard" v-move="closeHandler" v-tap="closeHandler"><section class="key-board" v-tap="defaultHandler">'
  			+ '<div class="k-header"><span v-tap="closeHandler">完成</span></div><div class="board">'
			+ '<span v-tap="{fn: clickHandler, name: 1}">1</span><span v-tap="{fn: clickHandler, name: 2}">2</span>'
			+ '<span v-tap="{fn: clickHandler, name: 3}">3</span><span v-tap="{fn: clickHandler, name: 4}">4</span>'
			+ '<span v-tap="{fn: clickHandler, name: 5}">5</span>'
			+ '<span v-tap="{fn: clickHandler, name: 6}">6</span><span v-tap="{fn: clickHandler, name: 7}">7</span>' 
			+ '<span v-tap="{fn: clickHandler, name: 8}">8</span><span v-tap="{fn: clickHandler, name: 9}">9</span>'
			+ '<span class="iconfont icon-dian" v-tap="{fn: clickHandler, name: \'point\'}"></span>'
			+ '<span v-tap="{fn: clickHandler, name: 0}">0</span><span class="iconfont icon-changjiantou-zuo" v-tap="delHandler"></span></div></section></div>',
  props: ['income', 'max', 'min'],
  data: function(){
  	return {
  		inputMax: this.max,
  		inputMin: this.min
  	}
  },
  methods: {
    clickHandler: function (val) {   
    	var pointRE = /\./;
    	var result = {};
    	var tempIncome = this.income || '';
    	val = val.name;
    	
    	if (tempIncome.length === 0 && (!val || val == 'point')) {
    		return;
    	}
    	if (val === 'point') {
    		
	    	if (!pointRE.test(tempIncome)) {
		    	val = '.';
	    	} else {
	    		return;
	    	}
    	}		
      	tempIncome += '' + val;
      	
      	if (Number(tempIncome) > Number(this.inputMax)) {
      		
      		if (tempIncome.length > 9) {
	      		tempIncome = tempIncome.slice(0, -1)
      		}
      		result = {disabledMax: true}
      	} else if (Number(tempIncome) < Number(this.inputMin)) {
      		result = {disabledMin: true}
      	}
      	this.emitHandler(app.extend(result, {val:tempIncome}));
    },
    delHandler: function(){
    	var result = {};
    	var tempIncome = this.income;
    	tempIncome = tempIncome.toString().slice(0, -1);	
    	
    	if (this.inputMin) {
    		if (Number(this.baseNum) < Number(this.inputMin)) {
	      		result = {disabledMin: true}
	      	}	
    	}
    	
    	this.emitHandler(app.extend(result, {val: tempIncome}));
    },
    closeHandler: function() {
    	this.$emit('close');
    },
    emitHandler: function(val){
    	this.$emit('input', val);
    },
    defaultHandler: function(){
    	
    }
  }
})
