/**
 * Created by tuchl on 2016-08-12.
 */
(function ($) {
    var page_num = 1;
    var page_count = 1;
    var page_size = 10;
    var appendTime = 0;
    var emptyTemplate ='<div id="empty" class="empty-item"><span class="fa fa-3x fa-newspaper-o color-dark"></span><p class="color-dark">没有收藏文章</p></div>';
    var pullUpTips = null;
    var getListHtml = function(list){
    	var html = [],item;
		for(var i=0,len=list.length;i<len;i++){
			item = list[i];
			html = html.concat([
				'<li class="mui-table-view-cell mui-media mui-transitioning">',
			    	'<div class="mui-slider-right mui-disabled">',
						'<a class="mui-btn mui-btn-red">删除</a>',
					'</div>',
			        '<a class="mui-slider-handle to_article" aId="',item.id,'">',
			        	'<span class="doc-data mui-hidden"',
			        		' type="',item.type,'"',
			        		' videoUrl="',item.type===2?item.videoUrl:'','"',
			        		' authorName="',item.authorName,'"',
			        		' authorHeadPath="',item.authorHeadPath,'">',
		        		'</span>',
			            '<div class="doc-thumbs mui-media-object mui-pull-left">',
			            	item.image?'<img src="'+item.image+'" />':'',
			            	item.type===2?'<div class="video-cover">'
			            		+ '<span class="video-btn fa fa-video-camera"></span>'
			            	+ '</div>':'',
			            '</div>',
			            '<div class="mui-media-body">',
			                '<div class="doc-title mui-h4 mui-ellipsis">',
			                	item.title,
			                '</div>',
			                '<p class="mui-ellipsis">',item.introduce,'</p>',
			                '<p class="mui-h6">',
			                    '<span class="mui-pull-left">',item.typeName,'</span>',
			                    '<span class="mui-pull-right">',item.releaseDate,'</span>',
			                '</p>',
			            '</div>',
			        '</a>',
			    '</li>']);
	   }
	   return html.join('');
    };
    
    var pullRefresh = function (pageIndex,pullSel,dir){
	    	var notNetwork = g('notNetwork');
	    	if(!app.checkLogin()) return;
	    	if(pageIndex===1){
	    		if(pullSel) pullSel.refresh(true);
	    	}
        newsSvc.getCollectionNewsList(pageIndex,page_size).then(function(data){
	        	if(notNetwork) g('content').removeChild(notNetwork);
	        if(!data.list){
	        		g('content').innerHTML = emptyTemplate;
	        }else{
	        		page_num = data.pagination.pageNum;
        			var pagesize = data.pagination.pageSize;
	            page_count = parseInt((data.pagination.totalItems+pagesize-1)/pagesize);
	            pullUpTips.style.display=data.pagination.totalItems<=pagesize?'none':'block';
	            if(page_num===1) g('favorites').innerHTML='';
	            g('favorites').innerHTML += getListHtml(data.list);
			}
            if(pullSel && dir) pullSel.endPullDownToRefresh();
			if(pullSel) pullSel.endPullUpToRefresh(page_num>=page_count);
        }).catch(function(err){
       	 	if(err.code=='0'){
	        		if(!notNetwork){
	        			var div = document.createElement('div');
		        		div.id="notNetwork";
		        		div.innerHTML = '<div class="not-network"><span>点击页面 重新加载</span></div>';
						g('content').appendChild(div);
	        		}
			}else{
				$.toast(err.message);
			}
        		if(pullSel && dir) pullSel.endPullDownToRefresh();
			if(pullSel && !dir) pullSel.endPullUpToRefresh();
			console.error(err.message,err);
        });
    };
    
    var openArticlePage = function () {
       	var img = this.querySelector('.doc-thumbs img');
       	var data = this.querySelector('.doc-data');
	    var params = {
	    	aId:this.getAttribute("aId"),
	    	title:this.querySelector('.doc-title').innerText,
	    	image: encodeURIComponent(img?img.src:''),
	    	type:data.getAttribute('type'),
	    	videoUrl:data.getAttribute('videoUrl'),
	    	authorName:data.getAttribute('authorName'),
	    	authorHeadPath:data.getAttribute('authorHeadPath')
	    };
	    app.openPage( params.type=='1' ? 'article': 'video', params)
    };
    $('.mui-table-view').on('tap','.to_article',openArticlePage);
    $('#favorites').on('tap', '.mui-btn', function(event) {
        var elem = this;
        var li = elem.parentNode.parentNode;
        var aid = elem.parentNode.nextElementSibling.getAttribute('aId');
        var btnArray = ['确认', '取消'];
        $.confirm('确认删除该条收藏记录？', '', btnArray, function(e) {
            if (e.index == 0) {
                newsSvc.collectionNews(aid,'0').then(function(){
                    li.parentNode.removeChild(li);
                });
            } else {
                setTimeout(function() { $.swipeoutClose(li); }, 0);
            }
        });
    });
    $('#content').on('tap','.not-network',function(){ 
    	pullRefresh(1); 
    });
    
    $.init();
    
	var scroll = $('.mui-scroll-wrapper').scroll({
    	bounce: false,
		indicators: true,
		deceleration:mui.os.ios?0.003:0.0009
    });
    
    $.ready(function(){
    	$('#content').pullToRefresh({
			down: {
				callback: function() {
					var self = this;
					setTimeout(function() {
						pullRefresh(1,self,true);
					}, 100);
				}
			},
			up: {
				callback: function() {
					var self = this;
					setTimeout(function() {
						pullRefresh(page_num+1,self,false);
					},100);
				}
			}
		});
	    pullUpTips = g('pullRefresh').querySelector('.mui-pull-bottom-tips');
		pullUpTips.style.display='none';
		pullRefresh(1);
    });
   
	window.addEventListener('refresh_data',function(){
		pullRefresh(1);
	},false)
	
	
	
})(mui);