
	var cacheOfficialInfo = null;
	var bBtn = true;
	app.mui.init({swipeBack:true});
	new Vue({
		el: "#body",
		data:{
			cityData: {},
			paymentType: {isShow: false, options: [], value: ''},
			inputVals: {},
			fields: [
    		{"cityCode":"110000","type":"1","serialNumber":1,"paraValue":"account",
    		"isDisplay": "1",
    		"paraName":"公积金帐号","paraPrompt":"公积金官网账号","elementType":"text","elementValue":null},
    		{"cityCode":"110000","type":"1","serialNumber":2,"paraValue":"password","paraName":"公积金密码",
    		"isDisplay": "1",
    		"paraPrompt":"公积金官网密码","elementType":"password","elementValue":null},
    		{"cityCode":"110000","type":"1","serialNumber":3,"paraValue":"safeCode","paraName":"验证码",
    		"isDisplay": "1",
    		"elementType":"text","elementValue":'../images/yzm.gif'}
			],
			officialInfo: {},
			isSubmit: false
		},
		created: function(){
			var This = this;
			this._getCityName();
		},
		mounted: function(){
			var This = this;
			setTimeout(function(){
				var offsetH = g("tipsCon").offsetHeight+60;
	       		if(offsetH>document.documentElement.clientHeight*0.8){
	       			g('modal').querySelector('.modal-box').style.height='80%';
	       			g('modal').querySelector('.mui-scroll-wrapper').style.position='absolute';
	       			g('modal').querySelector('.mui-scroll').style.position='absolute';
	       		}else{
	       			g('modal').querySelector('.modal-box').style.height='auto';
	       			g('modal').querySelector('.mui-scroll-wrapper').style.position='static';
	       			g('modal').querySelector('.mui-scroll').style.position='static';
	       		}
				g('loginQs').addEventListener('tap', function() {
					var btnRect = g('loginQs').getBoundingClientRect();
					var modalHeight = g('modal').querySelector('.modal-box').offsetHeight;
					var setTop = btnRect.top - modalHeight - 1;
					var maxTop = app.headerH;
					
					if(setTop<maxTop){
			   			g('modal').querySelector('.modal-box').classList.add('middle');
			   			g('modal').querySelector('.modal-box').style.top='50%';
			   		}else{
			   			g('modal').querySelector('.modal-box').classList.remove('middle');
						g('modal').querySelector('.modal-box').style.top= setTop+'px';
			   		}
			        g('modal').classList.add('mui-active');
			    });
			    app.mui('#modal').on('tap','#closeTips',function(){
			    	g('modal').classList.remove('mui-active');
			    	return false;
			    });
			    app.mui('#modal .mui-scroll-wrapper').scroll().scrollTo(0,0);	
			}, 2000)
       		
		    // 监听城市变化
		    app.addEventListener('changeCity', function(e){
		    	This._setCity(e);
		    })
			progessBar.init(document.querySelector('.mui-content'),"background:#e53e46");
			app.mui('.mui-scroll-wrapper').scroll();
 		},
		methods: {
			_getCityName: function(){
				var city = app.getCity();
				this._setCity(city);
			},
			// 设置城市
			_setCity: function(city){
				this.cityData = city;
				this._getCityConfig(city.cityCode);		
			},
			_getCityConfig: function(cityCode){
				var This = this;
				
				gjjSvc.getBindCardInfor(cityCode).then(function(data) {
					
					cacheOfficialInfo = data.officialInfo;
					
					if (data.officialConfigList.length) {
						This.paymentType.isShow = false;
						data.officialConfigList[0].selected = true;
						This.paymentType.value = data.officialConfigList[0].officialCode;
						
						// 如果官网正在维护，提示
						This.promptStatus(data.officialConfigList, This.paymentType.value);
					}
					if(data.officialConfigList.length>1){
						This.paymentType.isShow = true;
						This.paymentType.options = data.officialConfigList;
					}
					
					if (cacheOfficialInfo) {
						This._setFields();
						This.officialInfo = cacheOfficialInfo[This.paymentType.value].cityInfo;
					}
					
					This.getSafeCode();
					
				}).catch(function(err){
					console.log(err)
					app.alert('此城市正在维护中，暂时不能登录，给您带来不便敬请谅解');
				});
			},
			/*验证是否官网在维护中*/
			promptStatus: function(officialConfigList, officialCode){
				var status = true;
				var msg = '';
				for(var i=0; i<officialConfigList.length;i++){
					var official = officialConfigList[i];
					if(officialCode===official.officialCode && official.officialStatus===2){ 
						msg = official.officialStatusMessage
						status = false;
						break;
					}
				}
				if(msg) app.toast(msg);
				return status;
			},
			/**
			 * 设置form field
			 */
			_setFields: function(src){
				var paraList = cacheOfficialInfo[this.paymentType.value].paraList;
				
				if (paraList.length == 0) {
					paraList = this.fields;
				}
				var result = this._serialzerOfficialSaveCodeUrl(paraList, src ? src : '../images/yzm.gif');
				this.fields = result;	
			},
			paymentChangeHandler: function(e){
				var oSelect = e.target;
				var optVal = null;
				var index = oSelect.selectedIndex;
				var options = this.paymentType.options;
				
				for (var i = 0; i < options.length; i++) {
					options[i].selected = false;	
				}
				options[index].selected = true;
				this.paymentType.value = options[index].officialCode;
				this.getSafeCode();
				this._setFields();
			},
			getSafeCode: function(){
				var This  = this;
				
				if (!bBtn) return;
				bBtn = false;
				gjjSvc.getSafeCode(this.paymentType.value).then(function (data) {
					This._setFields(data.saveCodePath);
					bBtn = true;
				}).catch(function (err) {
					console.error(err.message,err);
					bBtn = true;
					app.alert('连接公积金管理中心失败');
				});
			},
			
			//地区选择
			areaChangeHandler: function(e){
				var target = e.target;
				this.inputVals[target.getAttribute('id')] = target.value;
			},
			// 同意协议
			protocalChangeHandler: function(e){
				this.isSubmit = !this.isSubmit;
			},
			
			// 绑定公积金
			submitHandler: function(){
				var This = this;
				
				if (!This.isSubmit || !bBtn) return;
				bBtn = false;
				
				for ( var i = 0; i < This.fields.length; i ++) {
					
					if (!This.inputVals[This.fields[i].paraValue] && This.fields[i].isDisplay === '1') {
						app.toast(This.fields[i].paraName+'不能为空');
						bBtn = true;
						return;
					}	
				}
				
				This.inputVals.cityCode = This.paymentType.value;

				progessBar.startProgess();
				gjjSvc.analysisFundCard(This.inputVals).then(function (data) {
					if (!data) {
						return app.alert('', '登录账号失败');
					}
					var user = app.getUser();
					if(user){
			         	user.fundAcctId = data.fundAcctId;
			        	app.setState('info',user);
		        	}
					progessBar.stopProgess(function(){
			            app.openPage('./gjj-info.html', {"fundAcctId": data.fundAcctId, payCode: This.paymentType.value});
			            app.appRefresh();
			            setTimeout(function(){
				         var opener = plus.webview.currentWebview();
						 opener.hide();
						 opener.close();
			            }, 2000)
					});
					This._setDefaultCard(data.fundAcctId);
					bBtn = true;
				}).catch(function (err) {
					console.error(err.message,err);
					progessBar.hideProgess();
					bBtn = true;
					This.getSafeCode();
					app.alert(err.message);
				});
			},
			goPage: function(e) {
				var httpRE = /^http/;
				var url = e.url;
				if (httpRE.test(url)) {
					app.openUrl({url: url});
				} else {
					app.openPage(url, {type: 1});
				}
			},
			_serialzerOfficialSaveCodeUrl: function(officialList, src){
				var This = this;
				var result = [];
				return Array.isArray(officialList) && officialList.map(function(val){
					
					if (val.paraValue == 'safeCode') {
						val.elementValue = src;
						This.inputVals[val.paraValue] = '';
					} else if ((val.elementType==="select" || val.paraValue === 'selectCity') && typeof val.elementValue == 'string'){
					
						try {
							tempArr = JSON.parse(val.elementValue);
						
							result = tempArr.map(function(val){
								
								for (var k in val) {
									
								}
								return {name: k, val: val[k]};
							})
							result.unshift({name: '请选择', val: ''});
							val.elementValue = result;
						} catch (e) {
							console.log(e)
						} 
					}
					return val;
				})
			},
			_setDefaultCard: function(fundAcctId){
				gjjSvc.changeDefaultAccount(fundAcctId).then(function (data) {}).catch(function (err) {});
			}
		}
	})
