var viewApi = app.mui('#mainView').view({ defaultPage: '#info' });
var view = viewApi.view;
var cachePayBase = null;

//处理view的后退与webview后退
var oldBack = app.mui.back;
app.listenerBack([{
	view: 'fund-calc',
	eventName: 'refresh_data',
	data: {}
}])
var payCity = null;
var fundId = null;
var mixin = {
   methods: {
		    // 显示验证码
		toggleRefresh: function() {
			var This = this;
			var oParent = g(This.imgCodeId);
			var oInput = oParent.querySelector('input');
			this.getSafeCode(function () {
		        oInput.value = '';
				app.mui('#' + This.imgCodeId).popover('toggle');
				oInput.focus();
			});
		},
		getSafeCode: function (callback) {
			var This = this;
			var oParent = g(This.imgCodeId);
			
			var oImg = oParent.querySelector('img');
			var oInput = oParent.querySelector('input');
			callback = callback || $.noop;
			gjjSvc.getSafeCode(this.fundBaseInfo.payCity).then(function (data) {
				oImg.setAttribute('src',data.saveCodePath);
				callback();
			}).catch(function (err) {
				console.error(err.message,err);
				oImg.setAttribute('src','../images/yzm.gif');
				app.toast('连接公积金管理中心失败');
			});
		},
		/**
		 * 更新公共基金数据
		 */
		 refreshData: function() {
			var This = this;
			var oParent = g(This.imgCodeId);
			var oImg = oParent.querySelector('img');
			var oInput = oParent.querySelector('input');
			document.activeElement.blur();
			var code = oInput.value.trim();
			if(code.length==0){
				oInput.focus();
				return app.toast("请输入图形验证码");
			} 
			app.mui(oParent).popover('toggle');
			
			progessBar.startProgess();
			
			gjjSvc.refreshFund(code, fundId).then(function (data) {
				fundPayBaseData = data;
				progessBar.stopProgess(function(){
					This.isRefresh = true;
					
					// 更新
					This.getFundBaseInfo(fundId, true);
				});
			}).catch(function (err) {
				console.error(err.message,err);
				This.isRefresh = false;
				progessBar.hideProgess();
				if(err.code=="90012"){
		    		app.confirm("公积金账户密码错误，如果您已修改密码请重新绑定账户。现在重新绑定账户？",
						"刷新公积金数据",['是','否'],function(event){
						if ( 0===event.index ) {
							oldBack();
		                }
					});
		    	}else if(err.code=="90008"){
		    		app.alert(err.message);
		    	}else if(err.message==='abort'){
		    		app.alert('请求异常终止，请返回并重新进入查看');
		    	}else{
					app.toast(err.message);	
				}
			});
		}
   }
}
new Vue({
	mixins: [mixin],
	el: '#info',
	data: {
		imgCodeId: 'first',
		fundBaseInfo: {},
		explanation: {},
		ifRefresh: true,
		joyApp: '',
	},
	created: function(){
		app.plusReady(function(){
			app.setBarStyle('light');
		});
		var userData = app.getUser();
		fundId = common.utils.queryString('fundAcctId') || userData.fundAcctId;
		payCity = common.utils.queryString('payCode');
		this.getFundBaseInfo(fundId);	
		setimmsend();
		var isRefresh = common.utils.queryString('isRefresh');
		// 更新公积金信息（验证码弹窗弹出） 
		if (isRefresh) {
			this.showImgCodeView();
		}
		function setimmsend(){
			var headers = document.querySelectorAll('.mui-bar');
			var conts = document.querySelectorAll('.mui-pages');
			
			if (app.imbarH) {
				
				for (var i = 0; i < headers.length; i ++) {
					headers[i].style.paddingTop = app.imbarH + 'px';
					headers[i].style.height = app.headerH + 'px';
				}
				for (var i = 0; i < conts.length; i ++) {
					conts[i].style.top = app.headerH + 'px';
					if (app.platform.iphoneX) {
						conts[i].style.paddingBottom = '235px'
					}
				}
			}
			progessBar.init(document.querySelector('.mui-pages'),"background:#FE4E50");
		}
	},
	mounted: function(){
		var This = this;
		var guideVer = myStorage.getItem("guideFundDetail");
		var appVer = myStorage.getItem('appver');
		
		if (guideVer != appVer) {
			myStorage.setItem("guideFundDetail", appVer);
			DOM.guide({
				target: document.querySelector('.change button'),
				targetStyle: {
					width: '100%',
					textAlign: 'right',
					color: '#fff',
					fontSize: '15px'
				},
				parentStyle: {
					width: '50px',
					right: '20px',
					left: 'none',
				},
				child: '<img style="width: 100%; position: fixed; top: 60px; left:0" src="../images/guide-fund-detail.png"/>'
			}, true)		
		}
		window.addEventListener("refresh_data",function () {
	    	var userData = {};
	    	
	    	if(app.checkLogin()){
	    		userData = app.getUser();
				This.getFundBaseInfo(userData.fundAcctId);
	    	}
	    }, false);
	    app.mui('body').on('tap', '.change button', function(){
	    	app.openPage('fund.bind.html');
	    })
	},
	methods: {
		
		
		getFundBaseInfo: function(fundId, update){
			var This = this;
			gjjSvc.getFunInfo(fundId,update).then(resultHandler).catch(function(err){
				console.error(err.message,err);
				if(err.code>9999) app.toast(err.message); 
			});	
			
			function resultHandler(data){
				This.fundBaseInfo = data;
				This.getExplanation(data.payCity);
				This.ifRefresh = false;
				This.showTools(data.payCity);
				payCity = data.payCity;
				cachePayBase = data;
				setTitName(data.name);
			}
			function setTitName(name){
				var titles = document.querySelectorAll('.fund-name');
				
				for (var i = 0; i < titles.length; i ++) {
					titles[i].innerHTML = name;
				}
			}
		},
		
		// 获取解释名词
		getExplanation: function(payCity){
			var This = this;
			shebaoSvc.getNounsExplanation(payCity).then(function(data){
				This.explanation = {
					expId:data.fund ? data.fund : '0'
				}
			}).catch(function(err){
				console.error(err.message,err);
				app.toast(err.message);
			});
		},
		showTipsHandler: function(){
			var This = this;
			if (!This.explanation.expHtml) {
				app.showWaiting();
				newsSvc.documentContent(This.explanation.expId).then(function(data){
					app.closeWaiting();
					This.explanation = {expId: This.explanation.expId, expHtml: data.content};
					app.mui('#tipBox').popover('show');
				}).catch(function(err){
					plus.nativeUI.closeWaiting();
					app.toast(err.message);
					console.error(err.message,err);
				});
				
			}else {
				app.mui('#tipBox').popover('show');
			}
	
		},
		guideUrls: [],
		
		//设置公积金缴纳等说明
		showTools: function(code){
			var cityCodes = [
		  		"110000","130100","310000","330100","330200","350200",
		  		"370200","440100","440300","441900","500000","510100"
			];
			if(cityCodes.indexOf(code)>=0){
		  		
		  		this.guideUrls=[ 
			 		app._webUrl+'/app/fund/'+code+'/gjj-tiqu.html', 
			 		app._webUrl+'/app/fund/'+code+'/gjj-daikuan.html'];
				
			}
			
		},
		
		// 显示弹窗去往查悦社保app
		showTarget: function(){
			var This = this;
			this.checkThridApp();
			
			if (app.platform.ios) {
				app.alert("推荐使用查悦社保APP查看", '', '关闭', '', 'div');
				
			} else {
				app.mui.confirm('', '推荐使用查悦社保APP查看', ['取消','确定'], function(event){

					if (event.index == 1) {
						This.goThridApp();	
					}
				}, 'div')	
			}
		},
		
		// 查悦社保APP
		checkThridApp: function(){
			var This = this;
			app.plusReady(function(){

				if(plus.runtime.isApplicationExist({pname:'com.joyshebao.joy',action:'joyshebao://'})){
					This.joyApp = true;
					console.log(true);
				} else {
					console.log(false)
				}
			})
			
		},
		
		// 跳转到第三方APP
		goThridApp: function(){
			var url = '';
			
			if (this.joyApp) {
				 
				if (app.platform.android) {
					// com.joyshebao.joy (生产包名)
					plus.runtime.launchApplication( {pname:"com.joyshebao.joy"}, function ( e ) {});
				} else if ( app.platform.ios) {
					plus.runtime.launchApplication( {action:"joyshebao://"}, function ( e ) {});
				}	
			} else {
				
				
				if(app.platform.android){
					url = 'https://app.joyshebao.com/loadingPlat/getUrlToLoadApp?para=a353acaf7f16608596a0742ecee7279d6d63f4f1678366';
				}else if(mui.os.ios){
					url = 'itms-apps://itunes.apple.com/us/app/id1136573266';
				}	
				plus.runtime.openURL(url);
			}
		}, 
		
		// 显示验证码
		showImgCodeView: function () {
			this.toggleRefresh();
		},
		
		// 更新公积金所有数据
		refreshHandler: function () {
			this.refreshData()
		},
		refreshSafeCode: function(e){
			this.getSafeCode();
		},
		goPage: function(e){
			var url = e.url || e;
			
			switch (url) {
				case 0:
					url = this.guideUrls[0];
				break;
				case 1:
					url = this.guideUrls[1];
				break;
//				default:
					
			}
			
			if (!url) {
				return app.alert('该城市暂无相关信息！','提示','确定',function(){},'div');
			}
			app.openPage({url:url})
		}
		
	}
});

new Vue({
	mixins: [mixin],
	el: '#detail',
	data: {
		imgCodeId: 'seconde',
		fundBaseInfo: {},
		fundList: [],
		warmTips: ''
	},
	created: function(){
		var userData = app.getUser();
		fundId = common.utils.queryString('fundAcctId') || userData.fundAcctId;
		payCity = common.utils.queryString('payCode');
		this.getFundBaseInfo(fundId);
//		app.mui('#detail .mui-scroll-wrapper').scroll();
	},
	mounted: function(){
		var This = this;
		app.addEventListener("refresh_data",function () {
	    	var userData = {};
	    	if(app.checkLogin()){
	    		userData = app.getUser();
				This.getFundBaseInfo(userData.fundAcctId);
	    	}
	    }, false);
	},
	methods: {
		getFundBaseInfo: function(fundId, update){
			var This = this;
			
			gjjSvc.getFunInfo(fundId,update).then(resultHandler).catch(function(err){
				console.error(err.message,err);
				if(err.code>9999) app.toast(err.message); 
			});
			function resultHandler(data){
				This.fundBaseInfo = data;
				This.getFundList(fundId);
				payCity = data.payCity;
				This.getFundWarmTips(payCity);
			}
			
		},
		// 获取温馨提示
		getFundWarmTips: function(payCity){
			var This = this;
			
			shebaoSvc.getFuncExplanation(payCity).then(function(data){
				
				if(data[4]){
					This.warmTips = data[4];
				}
			});
		},
		getFundList: function(fundId){
			var This = this;
			var bBtn = true;
			gjjSvc.getFunAcctDetails(fundId).then(function(data){
				var tempData = null;
				
				for(var i in data){
					for(var j in data[i].fundInfoList){
						tempData = data[i].fundInfoList[j]; 
						var str = tempData.date;
						str = str.substring(0,2)+'-'+str.substring(2);
						tempData.date = str;
						tempData.growth = tempData.amount>0;
						tempData.lose =  tempData.amount<0;
					}
				}
				This.fundList = data;
				
			}).catch(function(err){
				console.error(err.message,err);
				app.toast(err.message);
			});
		},
		// 显示验证码
		showImgCodeView: function () {
			this.toggleRefresh();
		},
		
		// 更新公积金所有数据
		refreshHandler: function () {
			this.refreshData()
		},
		refreshSafeCode: function(e){
			this.getSafeCode();
		}
	}
});

