(function($,doc,app,auth) {
	var auths = {};

	var appendOauthBtn = function(el,auths){
		var faIcon = {
			weixin:'jcon jcon-weixin',
			qq:'jcon jcon-qq'
		};
		for (var auth in faIcon) {
			var col = doc.createElement('div');
			col.className="mui-col-xs-6";
			col.innerHTML='<span authId="'+auth+'" class="oauth-btn fa '+faIcon[auth]+'"></span>';
			el.appendChild(col);
		}
	};
	var loginBack = function(){
		app.appRefresh();
		mui.back();
	};
	var openBindMobile = function(ouser){
		if(plus.navigator.isImmersedStatusbar()) {
			plus.navigator.setStatusBarStyle(mui.os.ios?'UIStatusBarStyleBlackOpaque':'light');
		}
		$.openWindow({url:'auth-bind.html',id:'bind',extras:{ouser:ouser}});
	};

	var msgLogin = function(mobile,mcode,callback){
		callback = callback || $.noop;
	    if(!/^1[23456789]{1}\d{9}$/.test(mobile)){
	        return callback('手机号码错误');
	    }
	    if (!/^\d{4,}$/.test(mcode)) {
	        return callback('短信验证码错误');
	    }
	    if (!checkAgreement(mobile,g('login'))) {
		    return callback('须同意“用户协议”和“隐私政策”');
		}
		var loginfo = {mobile:mobile,rcode:mcode},
			cusInfo = app.getDeviceInfo(),
			city = app.getCity();
		$.extend(loginfo,cusInfo,city,{appVersion: '1.7.5',
				resVersion: '1.7.5'});
		window.plus&&plus.nativeUI.showWaiting('正在登录...');
	    userSvc.msLogin(loginfo).then(function(data){
	    	if (!data) return app.alert('登录失败，请重试');
	    	app.createState(data);
			loginBack();
			plus.nativeUI.closeWaiting();
	    }).catch(function(err){
	    	err && app.alert(err.message);
	    	plus.nativeUI.closeWaiting();
	    	if(err.code!==0){
	    		return callback(err.message);
	    	}
	    });
	};	
	var oauthLogin = function(){
		var oauth = auths[this.getAttribute('authId')];
		myStorage.setItem('notlock',true);
		plus.nativeUI.showWaiting("正在认证登录...");
		oauth.login(function() {
			oauth.getUserInfo(function() {
				var loginfo = {},
					ouser = auth.getOauthUser(oauth),
					cusInfo = app.getDeviceInfo(),
					city = app.getCity();
				$.extend(loginfo,ouser,cusInfo,city);
				userSvc.oauthLogin(loginfo).then(function (data) {
					plus.nativeUI.closeWaiting();
					$.toast("认证登录成功");
					app.createState(data);
					loginBack();
				}).catch(function (err) {
					plus.nativeUI.closeWaiting();
					
					// 绑定手机号码
					if(err.code===30010){
						openBindMobile(ouser);
					}else{
						$.toast(err.message);
					}
				});
			}, function(e) {
				plus.nativeUI.closeWaiting();
				$.toast("获取用户信息失败");
			});
		}, function(e) {
			plus.nativeUI.closeWaiting();
			$.toast("登录认证失败");
		});
	};
	var getRcode = function (sec,intSms) {
 		if(getMcodeBtn.getAttribute("run")==="1") return;
		if(!/^1[23456789]{1}\d{9}$/.test(mobileBox.value)){
			$.toast('请输入正确的手机号码');
		}else{
			getMcodeBtn.innerHTML = '<i class="mui-spinner" style="margin:10px"></i>';
			userSvc.sendOptSms(mobileBox.value,'LOGIN_AuthCode').then(function (data) {
				mcodeBox.focus();
				$.toast('验证码已发送');
				sec = 60;
				intSms = setInterval(function () {
					getMcodeBtn.setAttribute("run","1");
					sec--;
					if(sec <= 0){
						clearInterval(intSms);
						getMcodeBtn.setAttribute("run","0");
						getMcodeBtn.innerHTML = '获取验证码';
					}else{
						getMcodeBtn.innerHTML = sec+'s';
					}
				},1000);
			}).catch(function (err) {
				getMcodeBtn.setAttribute("run","0");
				getMcodeBtn.innerHTML = '重新获取';
				$.toast(err.message);
			});
		}
	};
	
	var oauthArea = doc.querySelector('.oauth-area .oauth-btns'); 
	var loginButton = doc.getElementById('login');
	var accountBox = doc.getElementById('account');
	var passwordBox = doc.getElementById('password');
	var mobileBox = doc.getElementById('mobile');
	var mcodeBox = doc.getElementById('mcode');
	var regButton = doc.getElementById('reg');
	var forgetButton = doc.getElementById('forgetPassword');
	var watchPassButton = doc.getElementById('watchPass');
	var getMcodeBtn = doc.getElementById("getMcode");

	$.enterfocus('#login-form1 input', function(){
		$.trigger(loginButton, 'tap');
	});
	g('parts').style.height = document.documentElement.clientHeight+'px';
	
	var iOut = null;
	g('mobile').addEventListener('focus',function(){
		clearTimeout(iOut);
		jel('.cloud').addClass('flap');
	},false);
	g('mobile').addEventListener('blur',function(){
		iOut = setTimeout(function(){
			jel('.cloud').removeClass('flap');
		},100);
	},false);
	g('mcode').addEventListener('focus',function(){
		clearTimeout(iOut);
		jel('.cloud').addClass('flap');
	},false);
	g('mcode').addEventListener('blur',function(){
		iOut = setTimeout(function(){
			jel('.cloud').removeClass('flap');
		},100);
	},false);
	$('.oauth-btns').on('tap', '.oauth-btn',oauthLogin);
	
	loginButton.addEventListener('tap', function(event) {
		document.activeElement.blur();
		setTimeout(function(){
			msgLogin(mobileBox.value, mcodeBox.value,$.toast);
		},10);
	},false);
 
	getMcodeBtn.addEventListener('tap',function(){
		getRcode(0,null);
	},false);
	
	var loginBtn;
	var checkAgreement = function(uid,btn){
		loginBtn = btn;
		var agreement = myStorage.getItem('agreement')||{};
		if(!agreement[uid]){
			showAgreement(uid,btn);
			return false;
		}
		return true;
	};
	
	var showAgreement = function(uid){
		g('mask').classList.add('active');
		g('agreements').classList.add('active');
		g('agreements').setAttribute('uid',uid);
	};
	g('quitAgree').addEventListener('tap',function(){
		g('mask').classList.remove('active');
		g('agreements').classList.remove('active');
	},false);
	
	g('sureAgree').addEventListener('tap',function(){
		var uid = g('agreements').getAttribute('uid');;
		var agreement = myStorage.getItem('agreement')||{};
		agreement[uid] = Date.now();
		myStorage.setItem('agreement',agreement);
		g('mask').classList.remove('active');
		g('agreements').classList.remove('active');
		if(loginBtn.id=='login') {
			$.trigger(loginBtn,'tap');
		}
	},false);
	$.plusReady(function() {
		var nw = plus.webview.currentWebview();

		if(plus.navigator.isImmersedStatusbar()){
			plus.navigator.setStatusBarStyle(mui.os.ios?'UIStatusBarStyleDefault':'dark');
		}
		
		var state = app.getState();
		if(nw.notback) $.back = function () {};
	});
	
}(mui,document,app,auth));