var calcMixin = {
	methods: {
		inputData: {},
		selectStatusChange: function() {
			this.select.isShowSelectOptions = !this.select.isShowSelectOptions
		},
		selectChange: function(e) {
			this.select.selectVal = e.name;
			this.select.payId = e.id;
			this._refresh();
		},
		showKeyboard: function(e) {
			this.show = "show";
			this.inputData = {};
			app.mui('.mui-scroll-wrapper').scroll().scrollTo(0,0,100);
		},
		keyboardClose: function() {
//			if (this.inputData.disabledMax === true) {
//				app.toast(maxInputFlag === 'income' ? '缴纳基数不能大于税前收入哦！' : '本市最高缴纳基数' + this.inputMax);
//			} else if (this.inputData.disabledMin === true) {
//				app.toast(minInputFlag === 'min' ? '本市最低缴纳基数' + this.inputMin : '');
//			}
			this.show = "";
			this._getProportion('input')
		},
		keyboardInput: function(e) {
			this.inputData = e;
			this._setInputVal(e.val, -1);
		},
		// 缴纳基数选择
		saveHandler: function(index) {
			var item = this.selectNavs[index];
			cacheSelectIndex = this.selectIndex;
			this.selectIndex = index;
			
			switch (item.id) {
				case 'low':
					this._getProportion(item.id);
					break;
				case 'high':
					this._getProportion(item.id);
					break;
				case 'no':
					this.noticeHandler(item.id);
					break;
				default:
					this._getOfficialPayBase();
			}
		},
		changeCity: function(key, data){
			var city = {cityCode: data.payCity, cityName: geo.getCityNameByCode(data.payCity)};
			myStorage.setItem('city',city);
			city.key = key;
			app.fireEvent('main', 'changeCity', city);
		},
		
		/**
		 * 设置input
		 * @param {Object} val value
		 * @param {Number} index nav点击的索引
		 */
		_setInputVal: function(val, index){
			 val = Number(val);
			
			if (isNaN(val)) return;
			this.baseNum = (val === 0 ? '' : val);
			
			// 公积金官网
			if (/[0-9\-1]/.test(index)) { 
				this.selectIndex = index;
			}
		},
		
		
		// 计算公积金缴纳详情
		_calculateFund: function(res) {
			
			if (Number(res.addAmount) > 0) {
				payPrice = (res.addAmount / 2).toFixed(2);
				this._setInputVal(res.payBase, 0);
				this._getFundProportion();
			}
		},
		
		// 显示隐藏查询提示
		toggleShowConfirm: function(){
			this.showConfirm = !this.showConfirm ;
		},
		// confirm确定
		confirmBtnHandler: function(e) {
			this.toggleShowConfirm();
			
			// 查询
			if (e) {
				this.goPage({isRefresh: true});
			} else {  // 不查询
				this._setInputVal(this.baseNum, cacheSelectIndex);
			}
	
		},
		_showGuide: function() {
			
			DOM.guide({
				target: document.querySelector(".chose-btn a"),
				targetStyle: {
					width: '100%',
					color: '#fff',
					padding: '4px',
					fontSize: '24px',
					borderRadius: '8px',
					background: '#fff'
				},
				parentStyle: {
					width: '60px',
					marginLeft: '15px',
					height: '30px'
				},
				child: '<div class="first-guide">3</div>'
			}, true);
			DOM.guide({
				target: document.querySelector(".gradient-box"),
				wrapClass: 'fund',
				targetStyle: {
					borderRadius: '8px',
				},
				child: '<div class="seconde-guide">1</div>'
			});
			DOM.guide({
				target: document.querySelector(".select-nav"),
				wrapClass: 'fund',
				targetStyle: {
					paddingLeft: '5px',
					paddingRight: '5px',
					borderRaidus: '8px',
					margin: 0
				},
				child: '<img style="width: 100%; position: absolute; top: 120%" src="../images/fund-guide.png"/><div class="thrid-guide">2</div>'
			})
			
		}	
	}
	
}
