var tax = {
		methods: {
			/**
			 * @param {Number} taxP
			 * 通过缴税计算出税前工资
			 *
			 */
			_getIncomeBytax: function(taxP) {
				let result = 0;
				// 36000基数
				if(1080 >= taxP) {
					result = taxP / .03;
					// 36000 - 144000  
				} else if(11880 >= taxp && 1080 > taxp) {
					result = (taxp + 2520) / .1;
				} else if(43080 <= taxP && 11880 > taxP) {
					result = (taxP + 16920) / .2;
				} else if(73080 <= taxP && 43080 > taxP) {
					result = (taxP + 31920) / .25;
				} else if(145080 <= taxP && 73080 > taxP) {
					result = (taxP + 52920) / .3;
				} else if(250080 <= taxP && 145080 > taxP) {
					result = (taxP + 85920) / .35;
				} else {
					result = (taxP + 181920) / .45
				}
				return 0 < result ? result : 0;
			},
			/**
			 * 累计缴税税额计算
			 * @param {Number} income
			 * 
			 */
			_getIterationTaxByincome: function(income) {
				let result = 0;
				// 36000基数
				if(36000 >= income) {
					result = income * .03;
					// 36000 - 144000  
				} else if(36000 <= income && 144000 > income) {
					result = income * .1 - 2520;
				} else if(144000 <= income && 300000 > income) {
					result = income * .2 - 16920;
				} else if(300000 <= income && 420000 > income) {
					result = income * .25 - 31920;
				} else if(420000 <= income && 600000 > income) {
					result = income * .30 - 52920;
				} else if(600000 <= income && 960000 > income) {
					result = income * .35 - 85920;
				} else {
					result = income * .45 - 181920;
				}
				return 0 < result ? result : 0;
			},
			/**
			 * 累计缴税税额计算
			 * @param {Number} income
			 * 
			 */
			_getTaxByIncome: function(income) {
				let result = 0;
				if(3000 >= income) {
					result = income * .03;
					// 36000 - 144000  
				} else if(12000 >= income && 3000 < income) {
					result = income * .1 - 210;
				} else if(25000 >= income && 12000 < income) {
					result = income * .2 - 1410;
				} else if(35000 >= income && 25000 < income) {
					result = income * .25 - 2660;
				} else if(55000 >= income && 35000 < income) {
					result = income * .30 - 4410;
				} else if(80000 >= income && 55000 < income) {
					result = income * .35 - 7160;
				} else {
					result = income * .45 - 15160;
				}
				return 0 < result ? result : 0
			},

			/**
			 * @param {Number} income 税前收入
			 * @param {Number} startNum 开始位置
			 * @param {Object} city 城市信息；
			 * @param {Object} cardData 社保缴纳费用
			 */
			getDefaultList: function(startNum, city, cardData) {
				let result = [];
				result.length = 12;
				result.map(function(val) {
					return val.city = city;
				})
				return this._iterationCount(result, startNum, cardData);
			},
			/**
			 * @param {Array} list 数组
			 * @param {Number} startNum 开始位置
			 *  @param {Object} cardData 社保缴纳费用
			 *  @param {Boolean} refresh 是否更新
			 */
			_iterationCount: function(list, startNum, cardData, refresh) {
				let count = 0;
				let securityCount = 0;
				let fundCount = 0;
				let result = [];
				for(let i = 0; i < list.length; i++) {
					if(!list[i]) {
						list[i] = {};
					}
					let val = list[i];

					if(i >= startNum && !val.edit || refresh) {
						// 默认递增
						let index = 0 < i ? i - 1 : 0;
						let sourceData = list[index];
						val.addAmount = sourceData.addAmount;
						val.fundP = parseFloat(sourceData.fundP || 0).toFixed(2);
						val.fundBaseNum = sourceData.fundBaseNum;
						val.fundNavData = sourceData.fundNavData;
						val.securityP = parseFloat(sourceData.securityP || 0).toFixed(2);
						val.securityBaseNum = sourceData.securityBaseNum;
						val.secNavData = sourceData.secNavData;
						val.city = (sourceData.payCity || sourceData.cityCode) ? geo.getCityNameByCode(sourceData.payCity || sourceData.cityCode) : app.getCity();
						if(cardData) {
							if('undefined' != typeof cardData.addAmount) {
								val.addAmount = parseFloat(cardData.addAmount).toFixed(2);
							}
							if('undefined' != typeof cardData.fundP) {
								val.fundP = parseFloat(cardData.fundP || 0).toFixed(2);
								val.fundBaseNum = cardData.fundBaseNum;
								val.fundNavData = cardData.fundNavData;
							}
							if('undefined' != typeof cardData.securityP) {
								val.securityP = parseFloat(cardData.securityP || 0).toFixed(2);
								val.securityBaseNum = cardData.securityBaseNum;
								val.secNavData = cardData.secNavData;
							}
							if(cardData.payCity) {
								val.city = geo.getCityNameByCode(cardData.payCity);
							} else if(cardData.city) {
								val.city = cardData.city;
							}
						}
					}
					if(0 >= val.securityP) {
						val.secNavData = JSON.stringify({
							name: '不缴纳',
							id: 'no'
						});
					}
					if(0 >= val.fundP) {
						val.fundNavData = JSON.stringify({
							name: '不缴纳',
							id: 'no'
						});
					}
					fundCount += Number(val.fundP || 0);
					securityCount += Number(val.securityP || 0);
					val.securityCount = parseFloat(securityCount).toFixed(2);
					val.fundCount = parseFloat(fundCount).toFixed(2);
					count += (Number(val.addAmount) || 0);
					val.count = count.toFixed(2);
					val.serialCity = JSON.stringify(val.city);
					result[i] = val;
				}
				return list;
			},
			/* 合并缴纳列表重复月份
			 * @param {Array} array 
			 * @param {Number} length 
			 */
			mergeFundList: function(array, length) {
				let result = [];
				let previouEmptyLenth = Number(array[0].month - 1);
				let len = previouEmptyLenth + array.length;
				for(let i = 0; i < length; i++) {
					if(i < previouEmptyLenth) {
						result[i] = {};
					} else {
						result[i] = array[i - previouEmptyLenth] || {};
					}
				}
				return result;
			},
			/**
			 * 序列化计算数据 (原始数据已经扣除了月度的专项扣除数，如果不想扣除参数第一位置传入找回的金额)
			 * @param {Object} data
			 * @param {Number} chosseMonthIndex 当前选择的月份
			 * @param {Boolean} isSpecailMonth 月度专项扣除数
			 * @param {Boolean} isSpecialYear 是不是计算年度的专项扣除
			 */
			serializeClacData: function(data, chosseMonthIndex, isSpecailMonth, isSpecialYear) {
				let result = [];
				let countPay = 0;
				for(let i = 0; i < data.length; i++) {
					let tempData = {};

					// 税前收入
					let curPay = Number(data[i].addAmount || 0);
					if(11 == i && isSpecialYear) {
						curPay -= Number(oApp.globalData.specialYearP || 0);
					}
					if(isSpecailMonth) {
						curPay -= Number(oApp.globalData.specialMonthP || 0);
					}
					curPay -= Number(data[i].fundP);
					curPay -= Number(data[i].securityP);
					curPay -= 5000
					tempData.month = i + 1;
					let incomeNum = Number(data[i].addAmount || 0) - Number(data[i].fundP || 0) - Number(data[i].securityP || 0);
					tempData.incomeNum = 0 < incomeNum ? parseFloat(incomeNum).toFixed(2) : 0;
					countPay += curPay;
					tempData.taxPayable = 0 < countPay ? countPay : 0;
					result[i] = tempData;
				}
				return result;
			},
			/**
			 * 创建原始数据
			 * @param {Number} income 月税前收入
			 * @param {Object} cardData 
			 */
			createSorucesData: function(income, cardData) {
				var deferred = Q.defer();
				var This = this;
				var sourcesIncomeList;
				// 没有月度计算
				if(!this.isCalc) {
					this.isCalc = true;
					This._getDefaultCalc(income, app.getCity().cityCode || 110000, true, true).then(function(res) {
						var securityP = res[0].perTotalNum;
						var fundP = res[1].perNum;
						var sourcesIncomeList = This.getDefaultList(0, app.getCity(), {
							addAmount: Number(income),
							securityP: securityP,
							securityBaseNum: income,
							fundBaseNum: income,
							fundP: fundP
						})
						app.setState('fundP', fundP);
						app.setState('securityP', securityP);
						app.setState('sourcesIncomeList', sourcesIncomeList);
						deferred.resolve()
					}).catch(function() {
						deferred.resolve();
					})
				} else {
					sourcesIncomeList = app.getState('sourcesIncomeList');
					This._iterationCount(sourcesIncomeList, 0, cardData, true);
					deferred.resolve();
				}
				return deferred.promise;
			},
			/*默认计算（社保缴纳费用为空的时候）
			* @param {Number} income 税前收入
			  @param {Number} cityCode 城市编码
			  @param {Boolean} fundRefresh 公积金是否刷新
			  @param {Boolean} securityRefresh 社保是否刷新
			*/

			_getDefaultCalc: function(income, cityCode, fundRefresh, securityRefresh) {
				var promiseArray = [];
				promiseArray.push(this._getSecurityProportion(income, cityCode, securityRefresh));
				promiseArray.push(this._getFundProportion(income, cityCode, fundRefresh))
				return Q.all(promiseArray);
			},
			/**
			 * 获取社保缴纳详情
			 * @param {Number} income 税前收入
			  @param {Number} cityCode 城市编码
			  @param {Boolean} 是否刷新
			  @parma {Function} callback
			 */
			_getSecurityProportion: function(income, cityCode, refresh, callback) {
				var This = this;
				var deferred = Q.defer();
				if(!refresh) {
					deferred.resolve();
				} else {
					//获取户籍类型
					calcService.getPayHomeType(cityCode).then((res) => {
						if(Array.isArray(res)) {
							This._getSecurityDetail(income, cityCode, res[0].payId).then(function(res) {
								callback && callback(res);
								deferred.resolve(res);
							}).catch(function() {
								deferred.resolve();
							})
						} else {
							deferred.resolve();
						}
					}).catch(function() {
						deferred.resolve();
					})
				}
				return deferred.promise;
			},
			/**
			 * @param {Number} cityCode 城市编码
			 * @param {Number} payId 户口类型
			 * @param {Number} income 税前收入
			 */
			_getSecurityDetail: function(income, cityCode, payId) {
				var deferred = Q.defer();
				// 获取缴纳详情
				calcService.getPaySecurityDetail(cityCode, payId, income).then(function(res) {
					deferred.resolve(res);
				}).catch(function(err) {
					deferred.resolve();
				})
				return deferred.promise;
			},
			/**
			 * 获取公积金缴费详情
			 * @param {Number} income 税前工资
			 * @param {Number} cityCode 城市编码
			 * @param {Boolean} refresh 是不是重新加载
			 * @parma {Function} callback
			 */
			_getFundProportion: function(income, cityCode, refresh, callback) {
				var deferred = Q.defer();
				if(!refresh) {
					deferred.resolve();
				} else {
					calcService.getPayFundDetail(cityCode, income).then(function(res) {
						callback && callback(res);
						deferred.resolve(res);
					}).catch(function(err) {
						deferred.resolve();
					})
				}
				return deferred.promise;
			}
		}
	}		