﻿(function($,myStorage,app,req,Q) {
	var svc = {};
 
	svc.getSafeCode = function (cityCode) {
		var url = app._baseUrl + '/grab/getSafeCode';
		return req.post(url,{"cityCode":cityCode,"grabType":"1"});
	};
 
	svc.refreshFund = function (code,accountId) {
		var url = app._baseUrl + '/grab/refreshFundCard';
		return req.post(url,{safeCode:code,accountId:accountId});
	};
 
	svc.analysisFundCard = function (data) {
		var url = app._baseUrl + '/grab/bindFundCard';
		return req.post(url,data);
	};
	 
	svc.changeDefaultAccount = function (accountId) {
		var url = app._baseUrl + '/grab/changeDefaultAccount';
		return req.post(url,{cardType:"1",accountId:accountId});
	};
	 
	svc.getFunInfo = function(fundAcctId,update){
		var deferred = Q.defer();
		var data = myStorage.getItem('FunInfo_'+fundAcctId);
		if(!data || update){
			var url = app._baseUrl + '/pool/getFunInfo';
			req.post(url,{fundAcctId:fundAcctId}).then(function(data){
				if(fundAcctId) refreshPayBaseData(fundAcctId, data);
				deferred.resolve(data);
				return data;
			});
		}else{
			deferred.resolve(data);
		}
		return deferred.promise;
		
		// 更新社保卡缓存信息
		function refreshPayBaseData(fundId, data){
			
			// 如果官网数据没有公积金缴存基数请按照国家规定的12%来计算
			data.payBase = (Number(data.addAmount)/2/.12).toFixed(2);
			myStorage.setItem('FunInfo_'+fundId,data);
		}
	};
	 
	svc.getNewFunPayList = function(fundAcctId){
		var url = app._baseUrl + '/pool/getNewFunPayList';
		return req.post(url,{fundAcctId:fundAcctId});
	};
	 
	svc.getFunAcctDetails = function(fundAcctId){
		var url = app._baseUrl + '/pool/getFunAcctDetails';
		return req.post(url,{fundAcctId:fundAcctId});
	};
	 
	svc.getHuKouType = function (cityCode) {
	    var url = app._baseUrl + '/calculator/getHuKouType/'+ cityCode;
	    return req.get(url);
    };
 
	svc.getTrialFund = function(trialFund){
		var url = app._baseUrl + '/calculator/trialFund';
		return req.post(url,trialFund);
	};
	
    //城市社保卡绑定参数
    svc.getCityConfig = function(code){
    	var url = app._baseUrl + '/grab/getCityConfig';
    	return req.post(url,{cityCode:code,cardType:1});
    };
    svc.getCityDetail = function(code){
    	var url = app._baseUrl + '/user/getCityDetail/'+code;
    	return req.get(url);
    };
    //参保类型和登录问题
	svc.getBindCardInfor = function(cityCode){
		var url = app._baseUrl + '/cityCommon/getAnalysisInfo';
		return req.post(url,{cityCode:cityCode,grapType:"1"})
	};
	window.gjjSvc=svc;
})(mui,myStorage,app,request,Q);
