(function($,myStorage,req,Q) {
	var svc = {};
	svc.documentContent=function(documentId){//显示文章内容
		var url = app._gwCons+'/document/documentContent/'+documentId;
		return req.get(url);
	};
	svc.getDocumenClassList=function(){//话题分类列表
		var url = app._gwCons+'/document/getDocumenClassList';
		return req.get(url);
	};
	
	//话题文章列表
	svc.getFollowDocumentList=function(pageNum,pageSize,cateId,cityCode,type){
		var url = app._gwCons+'/document/getFollowDocumentList';
		var data = {'pageNum':pageNum,"pageSize":pageSize,'type':type};
		if(cateId) data.documentSerial = cateId;
		if(cityCode) data.cityCode = cityCode;
		var thePromise = req.post(url,data);
		if(pageNum==1){
			thePromise.then(function(data){
				data.cateId = cateId;
				jdb.saveData('news',data);
				return data;
			});
		}
		return thePromise;
	};
	svc.getCacheDocumentList=function(cateId){
		return jdb.getData('news',cateId);
	};
	//话题文章列表
	svc.getCacheFollowDocumentList=function(pageNum,pageSize,cateId,cityCode,type){
		var url = app._gwCons+'/document/getFollowDocumentList';
		var data = {'pageNum':pageNum,"pageSize":pageSize,'type':type};
		if(cateId) data.documentSerial = cateId;
		if(cityCode) data.cityCode = cityCode;
		var thePromise = req.post(url,data);
		var cacheCallback,responsed;
		thePromise.onCache=function(callback){
			cacheCallback = callback;
			return thePromise;
		};
		if(pageNum==1){
			jdb.getData('news',cateId).then(function(data){
				if(!responsed && data && cacheCallback) cacheCallback(data);
			});
			thePromise.then(function(data){
				responsed = true;
				data.cateId = cateId;
				jdb.saveData('news',data);
			});
		}
		return thePromise;
	};
	
	//用户关注话题列表
	svc.getFollowClassList=function(){
        var url = app._gwCons+'/document/getFollowClassList';
        return req.get(url);
    };
    
    //用户关注、取关话题
    svc.modifyFollowClass=function(operation,documentSerial){
        var url = app._gwCons+'/document/modifyFollowClass';
        return req.post(url,{'operation':operation,'documentSerial':documentSerial});
    };
    //用户关注、取关话题
    svc.modifyFollowClassBatch=function(operation,documentSerials){
        var url = app._gwCons+'/document/batchModiFollClass';
        return req.post(url,{'operation':operation,'documentSerial':documentSerials});
    };
    
	//取消、收藏新闻
    svc.collectionNews=function(documentId,operation){
		var url = app._gwCons+'/document/collectionNews';
		return req.post(url,{'documentId':documentId,"operation":operation});
	};    
	
	//显示文章内容
	svc.documentContent=function(documentId){
		var url = app._gwCons+'/document/documentContent/'+documentId;
		return req.get(url);
	};
	
	//用户收藏文章列表
    svc.getCollectionNewsList = function (pageNum,pageSize) {
        var url = app._gwCons+'/document/getCollectionNewsList';
        return req.post(url,{'pageNum':pageNum,"pageSize":pageSize});
    };
    
    svc.getNewestSpecial = function () {
        var url = app._gwCons+'/document/getNewestSpecial';
        return req.get(url);
    };
    svc.getSpecialList = function (pageNum,pageSize) {
        var url = app._gwCons+'/document/getSpecialList';
        return req.post(url,{'pageNum':pageNum,"pageSize":pageSize});
    };
    
    svc.setDocumentForwardAmount = function (documentId) {
        var url = app._gwCons+'/document/setDocumentForwardAmount/'+documentId;
        return req.get(url);
    };
    svc.getRecommedDocList = function (cityCode,cateId,size) {
        var url = app._gwCons+'/document/getRecommedDocList';
        var data = {};
        if(cityCode) data.cityCode = cityCode;
        if(cateId) data.documentSerial = cateId;
        if(size) data.size = size;
        return req.post(url,data);
    };
    svc.getKeyWordDocList = function (keyWord,pageNum,pageSize,cityCode,type) {
        var url = app._gwCons+'/document/getKeyWordDocList';
        var data = {};
        if(cityCode) data.cityCode = cityCode;
        if(type) data.type = type;
        data.keyWord = keyWord;
        data.pageNum = pageNum;
        data.pageSize = pageSize;
        
        return req.post(url,data);
    };
     
    /**
     * 获取文章的所有评论
     * @param docId { Number } 文章的Id;
     */
    svc.getCommentAllList = function(docId, pageNum){
    	var url = app._gwCons+'/document/getAllReviewByDoc';
    
        return req.post(url, {docId: docId, pageSize: 20, pageNum: pageNum});
    };
    
    /**
     * 获取文章评论下的回复
     * @param  commentId{ Number } 评论的Id;
     */
    svc.getReplyList = function(commentId, pageSize){
    	var url = app._gwCons+'/document/getAllReplyByReviewId';
    	
        return req.post(url, {ReviewId: commentId, pageSize: pageSize});
    };
    
    /**
     * 评论文章
     * @param documentId { Number } 文章的ID
     * @param context { String } 评论的内容
	*/
	svc.commentArticle = function(documentId, context){
		var url = app._gwCons+'/document/createReview';
        var data = {
        	documentId: documentId,
        	context: context
        };
        return req.post(url,data);
	};
	
    /**
     * 回复评论
     * @param repId { Number } 评论的ID
     * @param context { String } 评论的内容
	*/
	svc.replycomment = function(repId, context){
		var url = app._gwCons+'/document/replayReview';
        var data = {
        	repId: repId,
        	context: context
        };
        return req.post(url,data);
	};
	
	/**
     * 删除评论
     * @param commentId { Number } 评论的ID
	*/
	svc.deleteComment = function(commentId){
		var url = app._gwCons+'/document/deleteReview';
        var data = {
        	reviewId: commentId,
        };
        return req.post(url,data);
	};
	
    /**
     * 点赞
     * @param type { Number } 0 =》文章  1=》评论
     * @param linkId { Number } 文章或评论的ID
     * @param isCancelFollow { Boolean } 是否赞  是=》 取消    否 =》 是
     */
    svc.follow = function(type, likeId, isCancelFollow){

    	var url = app._baseUrl + (isCancelFollow ? '/document/canclesurportReview' : '/document/surportOrNotReview');
        var data = {
        	type: type,
        	likeType: '1',
        	likeId: likeId
        };
        return req.post(url,data);
    };
    
    /**
     * 我的评论文章list
	*/
	svc.getReviewedDocList = function(pageNum){
		var url = app._baseUrl + '/personCenter/getReviewedDocList';
        return req.post(url, {pageSize: 20, pageNum: pageNum});
	};
	
	/**
	 * 修改评论赞和回复的状态
	 * @param {Object} type
	 * @param {Object} statusType
	 * @param {Object} id
	 */
	svc.modityFollowState = function(type, statusType, id){
		var url = app._baseUrl + '/personCenter/modifyState';
		
        var data = {
        	type: type,
        	statustype: statusType,
        	id: id
        };
        return req.post(url,data);
	};
	
	/**
	 * 获取文章下的相关推荐
	 * @param {Number} documentSerial
	 * @param {Number} size 
	 */
	svc.docLikeRecommended = function(documentId, size){
		var url = app._gwCons+'/document/docLikeRecommended';
		var city = app.getCity();
		
        var data = {
        	documentId: documentId,
        	size: size || 10,
        	cityCode: city.cityCode
        };
        return req.post(url,data);
	};
	
	svc.addViewCount = function(id){
		var url = app._gwCons+'/document/addViewCount/'+id;
        return req.get(url);
	};

	svc.getDocVideoClassList = function(){
		var url = app._gwCons+'/document/getDocVideoClassList';
		return req.get(url);
	};
	
	svc.getVideoListById = function(videoId,pageIndex,pageSize){
		var url = app._gwCons+'/document/getVideoListById';
		return req.post(url,{
			videoId:videoId,
			pageNum:pageIndex,
			pageSize:pageSize
		});
	};
	
	svc.getVideoClassList = function(videoId,pageIndex,pageSize){
		var url = app._gwCons+'/document/getVideoClassList';
		return req.get(url);
	};
	
	svc.getHotKeywords = function(size){
		var url = app._gwCons+'/document/getHotKeyList';
		return req.post(url,{size:size});
	};
	
	svc.getKeyWordList = function(){
		var url = app._gwCons+'/document/getKeyWordList';
		return req.get(url);
	};
	
	svc.getCacheFeed = function(tabid){
		return jdb.getData("feedList",tabid).then(function(data){
			if(data && data.data){
				return data.data;
			}else{
				return [];
			}
		});
	};
	svc.getRecommendFeed = function(isFirst,pageNum){
		var url = app._gwCons + '/feed/getGroupRecommendFeed';
		var typeList = [1];
		var thePromise = req.post(url,{firstRequest:!!isFirst,typeList:typeList,pageNum:pageNum});
		thePromise.then(function(data){
			//if(isUpdate) jdb.saveData("feedList",{tabId:0,data:data);
			return data;
		}).catch(function(err){
			return err;
		});
		return thePromise;
	};
	svc.getChannelFeed = function(tab,pageNum,isUpdate){
		var url = app._gwCons +'/feed/getChannelFeed';
		return req.post(url,{tab:tab,pageNum:pageNum}).then(function(data){
			//if(isUpdate) jdb.saveData("feedList",{tabId:tab,data:data);
			return data;
		});
	};
	
	//获取微头条详情
	svc.getMinfo = function(id){
		var url = app._gwCons +'/minfo/getContentbyId?minfoId='+id;
		return req.get(url);
	};
	//获取微头条评论
	svc.getComments = function(id,pageSize,pageNo){
		var url = app._gwCons +'/minfo/getFirReviewList';
		var data = {"minfoId":id,"pageSize":pageSize,"pageNum":pageNo};
		return req.get(url,data);
	};
	//增加或者回复评论
	svc.addComments = function(data){
		var url = app._gwCons +'/minfo/addReview';
		return req.post(url,data);
	};
	//删除评论或者回复
	svc.deleteCommentReply = function(id,type){
		var url =  app._gwCons +'/minfo/delReview';
		var data = {"id":id,"type":type};
		return req.get(url,data);
	};
	//评论点赞
	svc.likeMan = function(id,otype,ctype){
		var url = app._gwCons +'/minfo/likeMan';
		return req.post(url,{likeId:id,likeType:otype,type:ctype});
	};
	svc.followMan = function(folType,followedId,userId){
		var url = app._gwCons +'/minfo/followMan';
		return req.post(url,{folType:folType,followedId:followedId,followId:userId,type:1});
	};
	
	//收藏、取消收藏
    svc.collect=function(documentId,operation){
		var url = app._gwCons+'/minfo/collectMan';
		return req.post(url,{'minfoId':documentId,"colType":operation});
	};  
	//获取评论下的回复
	 svc.getReply=function(c_id,num,size){
		var url = app._gwCons+'/minfo/getReview';
		return req.get(url,{'repViewId':c_id,"pageNum":num,"pageSize":size});
	};  
	//悦头条个人信息
	svc.getUserbyConId=function(id){
		var url = app._gwCons+'/minfo/getUserbyConId';
		return req.get(url,{'minfoId':id});
	};
	//用户所有微头条
	svc.getAllMes=function(authorId,num,size){
		var url=app._gwCons+'/minfo/getContentbyUserId';
		return req.get(url,{'releaseOperator':authorId,pageNum:num,pageSize:size});
	};
	//用户所有评论
	svc.getAllCom=function(authorId,num,size){
		var url=app._gwCons+'/minfo/getReviewbyUserId';
		return req.get(url,{'releaseOperator':authorId,pageNum:num,pageSize:size});
	};
	
	//新的收藏接口(头条和文章)
	svc.getFavoriteList = function(size,num){
		var url=app._gwCons+'/minfo/getCollectListByUserId';
		return req.post(url,{pageNum:num,pageSize:size});
	}
	//文章评论
	svc.getArticleCom = function(id,size,num){
		var url=app._gwCons+'/document/getFirstReviewListByUserId';
		return req.post(url,{reviewUserId:id,pageSize:size,pageNum:num})
	}
	//文章页功能导航
	svc.getEntranceByDocId = function(aid){
		var url = app._gwCons + '/document/getEntranceByDocId?type=1&docId='+aid;
		return req.get(url);
	};
	
	svc.getFavNum = function(){
        var url = app._gwCons + '/document/getCollectionNum';
        return req.get(url);
    };
	window.newsSvc=svc;
})(mui,myStorage,request,Q);
