﻿(function($,myStorage,req,Q) {
	var svc = {};
	//城市服务开通状态
	svc.getCityDetail = function(code){
    	var url = app._baseUrl + '/user/getCityDetail/'+code;
    	return req.get(url);
    };
	//城市社保绑卡参数
    svc.getCityConfig = function(code){
    	var url = app._baseUrl + '/grab/getCityConfig';
    	return req.post(url,{cityCode:code,cardType:0});
    };
	//绑定社保卡
    svc.bindSecurityCard = function (data) {
        var url = app._baseUrl + '/grab/bindSecurityCard';
        return req.post(url,data);
    };
    
	//切换默认账户
	svc.changeDefaultAccount = function (accountId) {
		var url = app._baseUrl + '/grab/changeDefaultAccount';
		return req.post(url,{cardType:"0",accountId:accountId});
	};
    //解析社保数据
	svc.analysisSecurity = function (data) {
		var url = app._baseUrl + '/grab/analysisSecurity';
		return req.post(url,data);
	};
    //刷新社保卡数据
	svc.refreshSecurity = function (code,accountId,phoneCode) {
		var url = app._baseUrl + '/grab/refreshSecurityCard';
		var data = {safeCode:code, accountId:accountId};
		if(phoneCode) data.phoneCode = phoneCode;
		return req.post(url,data, { headers: {
 				appVersion: '1.7.5',
				resVersion: '1.7.5'
 			}
 		});
	};


	//查询社保卡基本信息
	svc.getSecInfo = function(sbkid,update){
		var deferred = Q.defer();
		var data = myStorage.getItem('SecInfo_'+sbkid);
		if(!data || update){
			var url = app._baseUrl + '/pool/getSecInfo';
			req.post(url,{"securityAcctId":sbkid}).then(function(data){
				myStorage.setItem('SecInfo_'+data.id,data);
				deferred.resolve(data);
				return data;
			}).catch(function(err){
				deferred.reject(err);
			});
		}else{
			deferred.resolve(data);
		}
		return deferred.promise;
	};
	//查询最新缴费月份和险种明细
	// @param {String} update 
	svc.getNewSecPayList = function (sbkid, update) {
		var deferred = Q.defer();
		var data = myStorage.getItem('SecPayList_'+sbkid);
		if(!data || update){
			var url = app._baseUrl + '/pool/getNewSecPayList';
			req.post(url,{"securityAcctId":sbkid}).then(function(data){
				myStorage.setItem('SecPayList_'+sbkid, data);
				deferred.resolve(data);
				return data;
			}).catch(function(err){
				deferred.reject(err);
			});
		}else{
			deferred.resolve(data);
		}
		return deferred.promise;
	};
	//查询社保卡定点医疗机构
	svc.getSecHosList = function(sbkid){
		var url = app._baseUrl + '/pool/getSecHosList';
		return req.post(url,{"securityAcctId":sbkid});
	};
	//查询医疗账户和养老账户明细
	svc.getSecAcctDetails = function(sbkid, update){
		
		var deferred = Q.defer();
		var data = myStorage.getItem('SecAcctDetails_'+sbkid);
		if(!data || update){
			var url = app._baseUrl + '/pool/getSecAcctDetails';
			req.post(url,{"securityAcctId":sbkid}).then(function(data){
				myStorage.setItem('SecAcctDetails_'+sbkid, data);
				deferred.resolve(data);
				return data;
			}).catch(function(err){
				deferred.reject(err);
			});
		}else{
			deferred.resolve(data);
		}
		return deferred.promise;
	};
	//按条件查询缴费月份和险种明细
	svc.getSecPayListByMonth = function(sbkid,month){
		var url = app._baseUrl + '/pool/getSecPayListByMonth';
		return req.post(url,{"securityAcctId":sbkid,"payMonth":month});
	};
	//查询医保卡就医消费情况
	svc.getMedicalPay = function(sbkid, update){
		
		var deferred = Q.defer();
		var data = myStorage.getItem('MedicalPay_'+sbkid);
		if(!data || update){
			var url = app._baseUrl + '/pool/getMedicalPay';
			req.post(url,{"accountId":sbkid}).then(function(data){
				myStorage.setItem('MedicalPay_'+sbkid, data);
				deferred.resolve(data);
				return data;
			}).catch(function(err){
				deferred.reject(err);
			});
		}else{
			deferred.resolve(data);
		}
		return deferred.promise;
	};
	
	
    //[社保官网]用户获取官网发送的短信校验码方法
	svc.getTelcode = function(datasObj){
		var url = app._baseUrl + '/grab/getTelcode';
		return req.post(url,datasObj);
	};
	//[社保官网]获取验证码
	svc.getSafeCode = function (cityCode) {
		var url = app._baseUrl + '/grab/getSafeCode';
		return req.post(url,{"cityCode":cityCode,"grabType":"0"},{ headers: {
 				appVersion: '1.7.5',
				resVersion: '1.7.5'
 			}
 		});
	};
	
    //获取城市下的户口性质
    svc.getHuKouType = function (cityCode) {
        var url = app._baseUrl + '/calculator/getHuKouType/'+ cityCode;
        return req.get(url);
    };
    //获取全国城市列表
	svc.getCityList = function () {
		var url = app._baseUrl + '/user/getCityConfig';
        return req.get(url);
	};
	//新增：根据业务获取城市列表
	svc.getNewCityList = function (type) {
		
		if (typeof type === 'undefined') {
			return svc.getCityList();
		}
		var url = app._baseUrl + '/cityCommon/getCityList';
        return req.post(url,{buzzNum:type});
	};
	
	//名词解释
	svc.getNounsExplanation = function(cityCode){
		var url = app._baseUrl + '/joyNounsExp/getNounsExplanation';
		return req.post(url,{cityCode:cityCode})
	};
	
	//获取功能解释
	svc.getFuncExplanation = function(cityCode){
		var url = app._baseUrl + '/joyNounsExp/getFuncExplanation';
		return req.post(url,{cityCode:cityCode})
	};
	//参保类型和登录问题
	svc.getBindCardInfor = function(cityCode){
		var url = app._baseUrl + '/cityCommon/getAnalysisInfo';
		return req.post(url,{cityCode:cityCode,grapType:'0'});
	};
	window.shebaoSvc=svc;
	return svc;
})(mui,myStorage,request,Q);
