(function($,myStorage,app,req,Q) {
	var state = app.getState();
	var svc = {};
	svc.getUserInfo = function(update,notToLogin){
		var deferred = Q.defer();
		var userinfo = app.getUser();
		if(!userinfo || update){
			var url = app._gwUser + '/user/queryUser';
			var deviceInfo = app.getDeviceInfo();
			var location = myStorage.getItem('location');
			var network = myStorage.getItem('NetType');
			var push = app.getSetting('push')?'ON':'OFF';	
//			var geTuiId = (window.plus&&plus.push.getClientInfo()||{clientid:''}).clientid;
			var pobj = $.extend({network:network,push:push,geTuiId:'geTuiId'},deviceInfo,location,{appVersion: '1.7.5',
				resVersion: '1.7.5'});
			req.post(url,pobj,{notToLogin:notToLogin, headers: {
 				appVersion: '1.7.5',
				resVersion: '1.7.5'
 			}
 		}).then(function(data){
				app.setState('info',data);
				deferred.resolve(data);
				return data;
			}).catch(function(err){
				deferred.reject(err);
			});
		}else{
			deferred.resolve(userinfo);
		}
		return deferred.promise;
	};
	
	svc.sendOptSms = function (mobile,tplId) {
		var url = app._gwUser + '/sendMsg/sendOtpMessage';
		return req.post(url,{"mobile":mobile,"tplId":tplId});
	};
	svc.reg = function(data){
		var url = app._gwUser + '/user/registerUser';
		return req.post(url,data);
	};

    svc.login = function(data){
		var url = app._gwUser + '/user/userLogin';
		return req.post(url,data,{ headers: {
 				appVersion: '1.7.5',
				resVersion: '1.7.5'
 			}
 		});
	};
	svc.msLogin = function (data) {
		var url = app._gwUser + '/user/authCodeLogin';
		return req.post(url, data,{ headers: {
 				appVersion: '1.7.5',
				resVersion: '1.7.5'
 			}
 		});
	}
	svc.oauthLogin = function(data){
		var url = app._gwUser + '/user/thirdLogin';
		return req.post(url,data,{ headers: {
 				appVersion: '1.7.5',
				resVersion: '1.7.5'
 			}
 		});
	};
    svc.setUsername = function (uname) {
        var url = app._gwUser + '/user/modifyUserName';
        return req.post(url,{userName:uname});
    };
    
    svc.modifyUserHead = function (filePath,success,fail) {
        success = success || $.noop;
        fail = fail || $.noop;
        var url = app._gwUser + '/user/modifyUserHead';
        var task = plus.uploader.createUpload( url, {method:'POST'}, function ( t, status ) { // 上传完成
            if ( status == 200 ) {
                var data = JSON.parse(t.responseText);
                if(data.err)
                    fail(data.err);
                else
                    success(data.data);
            } else {
                fail({err:status,message:'上传文件出错'});
            }
        });
        
        var user = app.getUser();
		var cusInfo = app.getDeviceInfo();
        task.setRequestHeader('appid',cusInfo.appid);
        task.setRequestHeader('appVersion',cusInfo.appVersion);
        task.setRequestHeader('deviceId',cusInfo.deviceId);
        task.setRequestHeader('resVersion',cusInfo.resVersion);
        task.setRequestHeader('netType',plus.networkinfo.getCurrentType());
        task.setRequestHeader('userId',user.userId.toString());
        task.setRequestHeader('token',user.token);
        task.addFile( filePath, {key:"imageFile"} );
        task.addData("typeFile", "04" );
        task.start();
    };   
	svc.modifyPortrait = function (file) {
        var url = app._gwUser + '/user/modifyUserHead';
 		return req.postAddFiles(url,{
 			typeFile:'04'
 		},{
 			imageFile:file
 		}, { headers: {
 				appVersion: '1.7.5',
				resVersion: '1.7.5'
 			}
 		});
    };   
    svc.userActiveLog = function () {
		var data = {};
		var location = myStorage.getItem('location')||{};
		var city = myStorage.getItem('city')||{};
		
		data.appId = plus.runtime.appid;
		data.appVersion = plus.runtime.version;
		data.resVersion = myStorage.getItem('resver');
		if(location.address){
			data.country = location.address.country||'';
			data.provice = location.address.province||'';
			data.cityCode =	location.address.city||'';
			data.townCode = location.address.district||'';
			data.rowAdd = location.address.street||'';
			data.houseNummer = location.address.streetNumber||'';
			data.poiName = location.address.poiName||'';
			data.postalCode = location.address.postalCode;
			data.cityId = '';
			if(data.cityCode){
				var city = geo.getCityByName(data.cityCode);
				data.cityId = city.cityCode;
			}
		}
		data.coords = location.coords?'{latitude:'+location.coords.latitude+',longitude:'+location.coords.longitude+'}':'';
		data.address = location.addresses||'';
	 	data.coordsType = location.coordsType||'';

	 	data.deviceId = plus.device.uuid;
	 	data.deviceImei = plus.device.imei;
	 	data.deviceVendor = plus.device.vendor;
		data.deviceModel = plus.device.model;

		data.os = plus.os.name;
		data.osVersion = plus.os.version;
		data.osLanguage = plus.os.language;
		
		data.origin = plus.runtime.origin;
		data.launcher = plus.runtime.launcher;
		data.idfa = mui.os.ios?app.getIOSIdfa():'';
		data.channel = app.getChannel(); 
		
		data.innerVersion = plus.runtime.innerVersion;
		data.netType = plus.networkinfo.getCurrentType();
		data.timestamp = Date.now();
		
		if (mui.os.android) {
			data.androidId= getAndroidID();
		} 
		if (mui.os.ios) {
			data.Idfv = getIOSIdfv();
		}
        var url = app._gwUser + '/user/userActiveLog';
    	return req.post(url,data);
    	
    };
    function getAndroidID(){
    	var context = plus.android.runtimeMainActivity();
    	var Settings = plus.android.importClass("android.provider.Settings");
    	var androidId = Settings.System.getString(context.getContentResolver(), Settings.System.ANDROID_ID);
    	return androidId;
    }

	function getIOSIdfv(){
		try{
			var UIDevice = plus.ios.importClass("UIDevice");
			var currentDevice = UIDevice.currentDevice();
			var identifierForVendor = currentDevice.identifierForVendor();
			var idfv = plus.ios.invoke(identifierForVendor,"UUIDString");
			return idfv;
		}catch(e){
			return ''; 
		}
	}
	svc.getSwitch = function getSwitch(conditions) {
	    var url = app._gwUser + '/personCenter/getOpenRoot';
	    return req.post(url, { conditions: conditions });
	}
	window.userSvc=svc;	
})(mui,myStorage,app,request,Q);
