(function($,myStorage) {
	var app = {};
	app.needLoginCode = '30005';
	app.androidChannel = 'Android';
	app.iosChannel = 'AppStroe';
	app.urls = {
		'securityBind': {
			url: './security.bind.html',
			barColor: 'light'
		},
		'securityDetail': {
			url: './security.detail.html',
			barColor: 'light'
		},
		'fundBind': {
			url: './fund.bind.html',
			barColor: 'light'
		},
		'fundDetail': {
			url: './gjj-info.html',
			barColor: 'light'
		},
		'about': {
			url: './about.html',
			barColor: 'light'
		},
		'taxTeach': {
			url: './search_news.html?words=个税',
			barColor: 'dark'
		},
		'search': {
			url: './search_news.html',
			barColor: 'dark'
		},
		'chat': {
			url: './chat.html',
			barColor: 'dark'
		},
		'feedback': {
			url: './feedback.html',
			barColor: 'dark'
		},
		'openUrl': {
			url: './openUrl.html',
			barColor: 'dark'
		},
		'search': {
			url: './search_news.html',
			barColor: 'dark'
		},
		'article': {
			url: './article.html',
			barColor: 'dark'
		},
		'video': {
			url: './article-video.html',
			barColor: 'dark'
		},
		'agreement': {
			url: '/agreement.html',
			barColor: 'dark'
		},
		'privacy': {
			url: '/privacy.html',
			barColor: 'dark'
		},
		'gjjxieyi': {
			url: './gjj-xieyi.html',
			barColor: 'light'
		},
		'sbkxieyi': {
			url: './sbk-xieyi.html',
			barColor: 'light'
		},
		'city': {
			url: '/city.html',
			barColor: 'dark'
		},
		'login': {
			url: './login.html',
			barColor: 'light'
		},
	};
	(function(){
		var release = true;
		var testUrl = {
		  _baseUrl: 'https://app.chayueshebao.com',
		  _webUrl: 'https://m.chayueshebao.com',
		  _calcBaseURL: 'https://app.chayueshebao.com/calc',
		  _gwUser: 'https://app.chayueshebao.com/u',
		  _gwCons: 'https://app.chayueshebao.com/cons',
		  _imUrl: 'https://im.chayueshebao.com/im/text/1cgFdt.html'
		}
		var releaseUrl = {
		  _baseUrl: 'https://app.joyshebao.com',
		  _webUrl: 'https://m.joyshebao.com',
		  _calcBaseURL: 'https://app.joyshebao.com/calc',
		  _gwUser: 'https://app.joyshebao.com/u',
		  _gwCons: 'https://app.joyshebao.com/cons',
		  _imUrl: 'https://im.joyshebao.com/im/text/1cgFdt.html'
		}
		if (location.href.indexOf('8080') > -1) {
			app.originPlatform = 'web';
			testUrl = {
			  _baseUrl: 'http://10.1.3.32',
			  _webUrl: 'https://m.joyshebao.com',
			  _imURL: 'https://im.chayueshebao.com/im/text/1cgFdt.html',
			  _gwUser: 'http://10.1.3.32/u',
			  _calcBaseURL: 'http://10.1.3.32/calc',
			  _gwCons: 'http://10.1.3.32/cons'
			}
		}
		var tempUrl = release ? releaseUrl : testUrl;
		for (var i in tempUrl) {
			app[i] = tempUrl[i];
		}
	}())

 	function getState(key){
 		var state = null;
 		if(window.plus) 
 			state = myStorage.getItemPlus("StatePlus") || {};
 		else
 			state = myStorage.getItem("State") || {};
 		var res = key ? state[key]:state;
 		return res;
 	}
 	function setState(key,value){ 
 		var state = getState();
 		state[key] = value;
 		myStorage.setItem("State",state);
 		if(window.plus) myStorage.setItemPlus('StatePlus',state);
 	}
 	function createState(data){
 		var state = getState();
 		state.info = data;
 		state.token = data.token;
		myStorage.setItem("State",state);
		if(window.plus) myStorage.setItemPlus('StatePlus',state);
 	}
 	function siginOut(notToLogin){
 		var state = myStorage.getItem("State")||{},
			statePlus = myStorage.getItemPlus("StatePlus")||{},
			rf = state.token||statePlus.token;
 		if(state.token){
 			delete state.token;
	 		delete state.info;
	 		myStorage.setItem("State",state);
 		}
		if(statePlus.token){
			delete statePlus.token;
	 		delete statePlus.info;
	 		myStorage.setItemPlus('StatePlus',state);
		}
		if(rf && !notToLogin){
	 		toLogin();
			refresh();
		} 
 	};
 	function removeLogin(notToLogin){
		
		if(!notToLogin){
			window.plus && plus.webview.getLaunchWebview().evalJS('app.siginOut()');
		}else{
			window.plus && plus.webview.getLaunchWebview().evalJS('app.siginOut(1)');
		}
 	}

	function getDeviceInfo(vercode){
 		var cusinfo = app.getState("cusinfo")||{};
 		cusinfo.appVersion = vercode || myStorage.getItem('appver');
 		cusinfo.resVersion = myStorage.getItem('resver') || cusinfo.appVersion;
 		if(window.plus){
			cusinfo.deviceId = plus.device.uuid;
			cusinfo.deviceModel = plus.device.model;
			cusinfo.deviceVendor = plus.device.vendor;
			cusinfo.deviceImei = plus.device.imei;
			
			cusinfo.os = plus.os.name;
			cusinfo.osVersion = plus.os.version;
			cusinfo.osLanguage = plus.os.language;
			
			cusinfo.origin = plus.runtime.origin; 
			cusinfo.channel = getChannel();
			cusinfo.idfa = mui.os.ios?app.getIOSIdfa():'';
			cusinfo.appid = plus.runtime.appid;
			cusinfo.appVersion = plus.runtime.version;
			app.setState("cusinfo",cusinfo);
 		}
 		return cusinfo;
 	}
 	function getUser(){
		return getState('info');
	}
 	function checkLogin(){
		var token = getState('token');
		return token ? true :false;
	}
	function checkToLogin(){
		var token = getState('token');
		if(!token) toLogin(true);
	}
 	function getSetting(key){
 		var settings = myStorage.getItem("Settings")||{};
 		var res = key ? settings[key]:settings;
 		return res;
 	}
 	function setSetting(key,value){
 		var settings = myStorage.getItem("Settings")||{};
 		settings[key] = value;
 		myStorage.setItem("Settings",settings);
 	}
	function getCity(allowEmpty){
		var city = myStorage.getItem('city');
		if(!city && window.plus) city = myStorage.getCookiePlus('city',true);
        if(!city && !allowEmpty ) city = {cityName:'北京市',cityCode:'110000',geo:0};
		return city; 
	};
	function getVersionCode(callback) {
        callback = callback || $.noop;
        plus.runtime.getProperty(plus.runtime.appid, function(inf) {
            callback(inf.version);
            console.log("当前版本："+inf.version);
        });
    }
	function backToQuit(){
		
		if(typeof backButtonPress == 'undefined') backButtonPress = 0;
		backButtonPress++;
		if (backButtonPress > 1) {//一秒内连续按两次则推出
			plus.runtime.quit();
		} else {
			$.toast('再按一次退出应用');
		}
		setTimeout(function() {
			backButtonPress = 0;
		}, 1000); 
		return false;
	}    
	function testQuit(){
		$.oldBack = $.back;
		$.back = backToQuit;
	}	
	function toLogin(notBack){
		document.activeElement.blur();
		var lws = window.plus&&plus.webview.getWebviewById('login');
		if(!lws){
			app.openPage('login', {notback:notBack})
		}else{
			lws.show();
		}
	}
	function toKefu(){
		var customer = {data: {}};
		var chatWin = null;
		// 打开客服聊天界面
		openKefu(app._imURL);
      	function openKefu(url){
			if(window.plus){
				app.openPage('chat', {url: url});
			} else {
				window.open(url);
			}
		}
	}
	function showGuide(callback){
 		document.activeElement.blur();
 		var guide = $.preload({
			url:'_www/view/guide.html',
			id:'guide',
			styles:{zindex:99},
			show:{aniShow:'none'},
			waiting:{autoShow:false}
		});
 		guide.addEventListener('loaded',function(){
 			guide.show();
 			if(callback) callback();
 		},false);
	}
	
	function openUrl(options){
		options = $.extend({
			showCloseBtn:true,
			enableHistory:true,
			scalable:false
		}, options);
		app.openPage('openUrl', options);
	}
	
	function fireEvent(viewId,eventName,data) {
       if(app.originPlatform == 'web') {
	        console.log(JSON.stringify(data) +'==='+eventName);
	    	setItem(eventName, JSON.stringify(data));
	    } else {
	    	var view = viewId==='main' ? plus.webview.getLaunchWebview() : plus.webview.getWebviewById(viewId);
	        console.log('==='+eventName +";;" + JSON.stringify(data));
	        if(view) $.fire(view,eventName,data);
	    }
    }
	function refresh(){
       if(window.plus) {
            var views =  plus.webview.all();
	        for(var i=0;i<views.length;i++){
	            $.fire(views[i],'refresh_data');
	        }
        }
    }
    /**
	 * 打开新窗口
	 * @param {URIString} url : 要打开页面url
	 * @param {String} id : 要打开页面id
	 * @param {JSON} styles : 窗口样式
	 * @param {JSON} extras : 扩展参数
	 * @param {JSON} waiting : 显示等待框，默认为false
	 * @param {JSON} show : 页面loaded事件发生后自动显示，默认为true
	 */
    function openWebview(url,id,styles,extras,waiting,show){
    	//id,wa,ns,ws,extras
		if(window.plus){
			id = id || url
			var nw = plus.webview.getWebviewById(id);
			show = show || {autoShow:true,aniShow:'slide-in-right'};
			if(!nw){
				var waitingBox = null;
				styles = styles || {};
				extras = extras || {};
				styles.scrollIndicator||(styles.scrollIndicator='none');
				styles.scalable||(styles.scalable=false);
				waiting = waiting || {autoShow:false};
				if(waiting.autoShow) waitingBox=plus.nativeUI.showWaiting();
				nw=plus.webview.create(url,id,styles,extras);
				if(show.autoShow!=false){
					nw.addEventListener('titleUpdate',function(){
						nw.show(show.aniShow,show.duration);
						waitingBox&&waitingBox.close();
						waitingBox=null;
					},false);
				}
			}else if(nw.getURL()!==url){
				nw.loadURL(url);
			}else{
				nw.show(show.aniShow,show.duration);
			}
			return nw;
		}else{
			return window.open(url);
		}
    }
   	function hideWebview(id,st){
		$.later(function () {
            var view = plus.webview.getWebviewById(id);
            if(view) view.hide();
        },st || 10);
	}
    function closeWebview(id,st,ani) {
        $.later(function () {
            var view = plus.webview.getWebviewById(id);
            if(view) view.close(ani||'none');
        },st || 10);
    }
     
	function toggleHardwareAccelerated(webview,flag){
		if(typeof webview ==='string'){
			plus.webview.getWebviewById(webview).setStyle({hardwareAccelerated:false});
		} else if(typeof webview ==='object'){
			webview.setStyle({hardwareAccelerated:false});
		}
	}
	
	function showMask(){
 		app.mask = app.mask || $.createMask();
 		app.mask.show();//显示遮罩
 	}
	function closeMask(){
 		if(app.mask) app.mask.close();//关闭遮罩
 	}
	
	function copyText(text){
    	if(mui.os.ios){
    		var UIPasteboard  = plus.ios.importClass("UIPasteboard");
			var generalPasteboard = UIPasteboard.generalPasteboard();
			// 设置/获取文本内容:
			generalPasteboard.setValueforPasteboardType(text, "public.utf8-plain-text");
    	}else if(mui.os.android){
	        var Context = plus.android.importClass("android.content.Context");
            var main = plus.android.runtimeMainActivity();
            var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
            plus.android.invoke(clip,"setText",text);
    	}
    }
	function getIOSIdfa(){
		try{
			var ASIdentifierManager = plus.ios.importClass("ASIdentifierManager");
			var sharedManager = ASIdentifierManager.sharedManager();
			var advertisingIdentifier = sharedManager.advertisingIdentifier();
			var idfa = plus.ios.invoke(advertisingIdentifier,"UUIDString");
			return idfa;
		}catch(e){
			return ''; 
		}
	}
	function getIOSAppInfo(key){
		var NSBundle = plus.ios.importClass('NSBundle'),
			bundle = NSBundle.mainBundle(),
			infoDictionary = bundle.infoDictionary(),
			value = infoDictionary.plusGetAttribute(key);
		plus.ios.deleteObject(bundle);
		plus.ios.deleteObject(infoDictionary);
		return value;
	}
	function getIOSGPStatus(){
		var CLLocationManager = plus.ios.import("CLLocationManager");
		var authorizationStatus = CLLocationManager.authorizationStatus();
		return authorizationStatus;
   }
	function openIOSetting(url){
		plus.runtime.openURL(url);
	}
	function getAndroidAppMeta(key){
		var PackageManager=plus.android.importClass("android.content.pm.PackageManager");
		var context = plus.android.runtimeMainActivity();
		var appInfo=plus.android.invoke(context.getPackageManager(), "getApplicationInfo", context.getPackageName(),PackageManager.GET_META_DATA);
		return plus.android.invoke(appInfo.plusGetAttribute('metaData'),'getString',key.toString());
	}
	function getAndroidGPStatus(){
		var context = plus.android.importClass("android.content.Context");
        var locationManager=plus.android.importClass("android.location.LocationManager");
        var main=plus.android.runtimeMainActivity();
        var mainSvr=main.getSystemService(context.LOCATION_SERVICE);
        console.log(mainSvr.isProviderEnabled(locationManager.GPS_PROVIDER));
        return mainSvr.isProviderEnabled(locationManager.GPS_PROVIDER);
   }
	function openAndroidSettings(key){
		var main = plus.android.runtimeMainActivity();
		var Intent = plus.android.importClass("android.content.Intent");
		var Settingts  = plus.android.importClass("android.provider.Settings");
		var setting = new Settingts();
		var intent =  new Intent(setting[key]);
		main.startActivity(intent);
	}
	function openWeixin() {
	    if (plus.os.name == "android") {
	        plus.runtime.launchApplication( {pname:"com.tencent.mm"}
	            , function ( e ) {
	                plus.nativeUI.confirm( "检查到您未安装\"微信\"，是否到商城搜索下载？", function(i){
	                    if (i.index == 0) {
	                        plus.runtime.openURL("market://details?id=com.tencent.mm");
	                    }
	                } );
	        } );
	    } else if(plus.os.name == "ios") {
	        plus.runtime.launchApplication({action:"weixin://RnUbAwvEilb1rU9g9yBU"}, function ( e ) {
	            plus.nativeUI.confirm( "检查到您未安装\"微信\"，是否到商城搜索下载？", function(i){
	                if (i.index == 0) {
	                    plus.runtime.openURL("itms-apps://itunes.apple.com/cn/app/wechat/id414478124?mt=8");
	                }
	            });
	        });
	    }
	}
	
	function getChannel(){
		return mui.os.ios?app.iosChannel:app.getAndroidAppMeta('UMENG_CHANNEL')||app.androidChannel;
	}
	
	/**
	 * 获取自定义的 http header 
	 */
	function getCustomHeaders(){
		var state = app.getState() || {};
		var cusInfo = app.getDeviceInfo() || {};
		return {
			deviceId:cusInfo.deviceId,
			appid:cusInfo.appid,
			appVersion:cusInfo.appVersion,
			resVersion:cusInfo.resVersion,
			userId: state.info ? state.info.userId : '',
			token: state.token
		};
	}
	app.getDeviceInfo = getDeviceInfo;
	
	app.getState = getState;
	app.setState = setState;
	app.createState = createState;
	app.siginOut = siginOut;
	app.removeLogin = removeLogin; 
	app.getSetting = getSetting;
	app.setSetting = setSetting;
	app.getUser = getUser;
	app.checkLogin = checkLogin;
	app.checkToLogin = checkToLogin;
	app.getCity = getCity;
	app.getVersionCode = getVersionCode;
	app.toKefu = toKefu;
	
	app.toLogin = toLogin;
	app.showGuide = showGuide;
	app.openUrl = openUrl;
	
	app.backToQuit = backToQuit;
	app.testQuit = testQuit;
	
	app.toggleHardwareAccelerated = toggleHardwareAccelerated;
	app.openWebview = openWebview;
	app.hideWebview = hideWebview;
    app.closeWebview = closeWebview;
    app.fireEvent = fireEvent;
    app.appRefresh = refresh;
	app.showMask = showMask;
 	app.closeMask = closeMask;
	
	app.getChannel = getChannel;
	
	app.getIOSIdfa = getIOSIdfa;
	app.getIOSGPStatus = getIOSGPStatus;
	app.getIOSAppInfo = getIOSAppInfo;
	app.getAndroidAppMeta = getAndroidAppMeta;
	app.getAndroidGPStatus = getAndroidGPStatus;
	app.openAndroidSettings = openAndroidSettings;
	app.openWeixin = openWeixin;
	app.copyText = copyText;
	app.getCustomHeaders = getCustomHeaders;
    window.app= app;
    window.g = function(id){
		return document.getElementById(id);
	};
	return app;
	
})(mui,myStorage);
 
