(function($,app,Q) {
	var request = {};
	request.setting = {
		async:false,
		dataType:'json',
		timeout:100000,
		headers:{'Content-Type':'application/json'},
		waiting:false
	};
	request.request = function(url,options,setting){
		var deferred = Q.defer();
		var netState = window.plus ? plus.networkinfo.getCurrentType():myStorage.getItem('NetType');
		if(netState==='EMPTY' || netState===1){
			$.toast('网络不可用');
			deferred.reject({code:0,message:'网络不可用'});
		}else{
			var state = app.getState();
			var cusInfo = app.getDeviceInfo();
			var fextrs = {
				deviceId:cusInfo.deviceId,
				appid:cusInfo.appid,
				appVersion:cusInfo.appVersion,
				resVersion: '1.7.5'
			};
			if(window.plus) {
				fextrs.netType = plus.networkinfo.getCurrentType();
			}
			if(state.token){
				fextrs.userId = state.info ? ""+state.info.userId : undefined;
				fextrs.token = state.token || undefined;
			}
			setting = $.extend(true,{},request.setting,setting);
			
			headers = $.extend({}, fextrs, setting.headers);
			
			var waiting = null;
		    if(setting.waiting && window.plus){
		    	waiting = plus.nativeUI.showWaiting(request.setting.waiting.title);
		    }
		    var starttime = Date.now();
		    var postData = options.data; 	
			var processData = true;
			if(setting.contentType==false){
				postData = options.data;
				processData = false;
				delete headers['Content-Type'];//='multipart/form-data';
			}else if(headers['Content-Type']=='application/x-www-form-urlencoded'){
				postData = options.data;
				processData = true;//为true时自动serialize非字符串data
			}else if(headers['Content-Type']=='application/json'){
				postData = JSON.stringify(options.data);
				processData = false;
			}

			
			$.ajax(url,{
				data:postData,
				type:options.type,
				dataType:setting.dataType,
				timeout:setting.timeout,
				headers:headers,
				contentType:setting.contentType,
				processData:processData,
				success:function(data){
					if(window.plus) plus.nativeUI.closeWaiting();
					if(!data) return;
					if ('err' in data && data.err!==null) {
						if(data.err.code == app.needLoginCode){
							app.removeLogin(setting&&setting.notToLogin);
						}
						data.err.code = parseInt(data.err.code);
                        deferred.reject(data.err);
			       	} else if('data' in data){
			       		
			       		if ('500' == data.code) {
			       			mui.toast('服务器君罢工了，稍后再试');
			       			deferred.reject({code: '500', message: '服务器君罢工了，稍后再试'});
			       		} else {
			       			deferred.resolve(data.data);
			       		}

			    	}else{
			    		console.log(JSON.stringify(data));
			    	}
			        
					console.log("====================================================================");
					console.log("START Request==>"+options.type+":"+url);
					console.log("header:"+JSON.stringify(headers));
					console.log(options.type.toUpperCase()=="GET"?"":"data:"+JSON.stringify(options.data));			        
					console.log("Response:"+JSON.stringify(data));
					console.log("Consume:"+(Date.now() - starttime)+'ms');
					console.log("END Request==>"+options.type+":"+url);
					console.log("====================================================================");
 
				},
				error:function(xhr,type,errorThrown){
					if(window.plus) plus.nativeUI.closeWaiting();
					//"timeout,error，abort,parsererror，null"
					var msgs = {
						'timeout':'连接服务器超时',
						'error':'服务器维护中',
						'abort':'无法连接服务器请求已取消',
						'parsererror':'网络数据传输出错'
					};
					$.toast(msgs[type]);
					deferred.reject({code:xhr.status,message:type});
					console.log("====================================================================");
					console.log("START Request==>"+options.type+":"+url);
					console.log("header:"+JSON.stringify(headers));
					console.log(options.type.toUpperCase()=="GET"?"":"data:"+JSON.stringify(options.data));	
					console.log("Error:"+"status:"+xhr.status+',type:'+type+',error:'+errorThrown);
					console.log("END Request==>"+options.type+":"+url);
					console.log("====================================================================");
 
				}
			});
		}
		return deferred.promise;
	};
	request.get = function(url,setting){
		var promise = request.request(url,{type:'get'},setting);
		return promise;
	};
	request.post = function(url,data,setting){
		var promise = request.request(url,{type:'post',data:data},setting);
		return promise;
	};
	
	function getExtName(b64Str){
		var mimeTypes = {
			"text/plain": ".txt",
			"text/css": ".css",
			"text/xml": "xml",
			"text/html": ".html",
			"text/javascript": ".js",
			"image/jpeg": ".jpg",
			"image/png": ".png",
			"image/gif": ".gif",
			"image/svg+xml": ".svg",
			"image/tiff": ".tiff",
			"application/json": ".json",
			"application/pdf": ".pdf",
			"application/x-shockwave-flash": ".swf",
			"application/octet-stream": ".rar",
			"application/x-zip-compressed": ".zip",
			"audio/x-wav": ".wav",
			"audio/x-ms-wma": ".wma",
			"video/x-ms-wmv": ".wmv",
			"video/mp4": ".mp4"
		};
		var regx = /data:(.*);base64,/;
		var type = b64Str.match(regx)[1];
		return mimeTypes[type]||'';
	}
	function getBlobByBase64Code(b64Str){
		var regx = /data:(.*);base64,/;
		var type = b64Str.match(regx)[1];
        var b64 = b64Str.replace(regx,'');
        var binary = atob(b64);
        var array = [];
        for (var i = 0; i < binary.length; i++) {
            array.push(binary.charCodeAt(i));
        }
        var blob = new Blob([new Uint8Array(array)], {type: type});
        return blob;
	};
	
	request.postAddFiles = function(url,data,files,setting){
		setting = $.extend(true, {contentType:false}, setting);
		var formData = new FormData();
		for(var k in data){
			formData.append(k,data[k]);
		}
		for(var f in files){
			var file = files[f];
			if(typeof file=='object'){
				formData.append(f,file);
			}else if(typeof file=='string'){
				var now = Date.now();
				var ext = getExtName(file);
				var blob = getBlobByBase64Code(file);
				formData.append(f,blob,now+ext);
			}
		}
		var promise = request.request(url,{type:'post',data:formData},setting);
		return promise;
	}
	request.getImg = function(img,url,type,data){
		if(!url) return console.log('no img resource');
		type = type?type.toUpperCase():'GET';
		if(type=='GET'){
			var queryStr = '';
			for(var n in data){
				queryStr+='&'+n+'='+data[n];
			}
			url=url.indexOf('?')>0 ? url+queryStr.substr(1):url+queryStr;
		}
	    var xhr = new XMLHttpRequest();
	    xhr.open(type, url, true);
	    xhr.responseType = "blob";
	    
	    var state = app.getState();
		var cusInfo = app.getDeviceInfo();
		xhr.setRequestHeader("deviceId", cusInfo.deviceId);
    	xhr.setRequestHeader("appid", cusInfo.appid);
    	xhr.setRequestHeader("appVersion", cusInfo.appVersion);
    	xhr.setRequestHeader("resVersion", cusInfo.resVersion);
		if(window.plus) {
			xhr.setRequestHeader("netType", plus.networkinfo.getCurrentType());
		}
		if(state.info){
			xhr.setRequestHeader("userId", state.info.userId);
	    	xhr.setRequestHeader("token", state.token);
		}
	    xhr.onload = function() {
	        if (this.status == 200) {
	            var blob = this.response;
	            img.onload = function(e) {
	                window.URL.revokeObjectURL(img.src); 
	            };
	            img.src = window.URL.createObjectURL(blob);
	        }else{
	        	console.error(this.status);
	        }
	    }
	    xhr.send(type=='POST'?data:undefined);
	};
	
	window.request=request;
	return request;
})(mui,app,Q);
