(function($,myStorage,app){
	
	var updater = {
		appStoreUrl:'https://itunes.apple.com/us/app/id1136573266',
		androidUrl:'market://details?id=com.joyshebao.joy',
		checkUrl: app._baseUrl + "/user/versionInfoNew",
		data:{},
		get currAppVersion(){
			return myStorage.getItem('appver');
		},
		get currVersion(){
			return myStorage.getItem('resver');
		},
		isExist:function(){
   			return !!plus.webview.getWebviewById('update');
   		}
	};
	
	function formatDataOld(data){
		if(!data) return null;
		var newVersion = mui.os.android ? data.appVersionAndroid : data.appVersionIos,
			lowestVersion = mui.os.android ? data.lowestVersionAndroid : data.lowestVersionIos,
			isForceUpdate = updater.currVersion<lowestVersion;
		return {
			newVersion:newVersion,
			lowestVersion:lowestVersion,
			isForceUpdate:isForceUpdate,
			updateForce:data.updateForce,
			downloadAddress:data.downloadAddress,
			hash:data.hash,
			updateLogs:data.versionDescribe.replace(/\\n/g,'\n')
		};
	}
	function formatData(data){
		if(!data) return null;
		return {
			newVersion:data.appVersion,
			lowestVersion:data.lowestVersion,
			isForceUpdate:updater.currVersion<data.lowestVersion,
			updateForce:data.updateForce,
			downloadAddress:data.downloadAddress,
			hash:data.hash,
			updateLogs: data.versionDescribe && data.versionDescribe.replace(/\\n/g,'\n')
		};
	}
	function createUpdateView(){ 
		var nw = plus.webview.create('_www/static/old-calc/view/update.html','update',{
      		top:'0px',left:'0px',height:'100%',width:'100%',zindex:998,background:'transparent'
      	});
      	nw.show();
      	nw.addEventListener('loaded',function(){
      		updater.showPrompt();
      	},false);

       	updater.close = function () {
       		nw.evalJS('document.body.style.background="rgba(0,0,0,0)";');
       		setTimeout(function(){
       			nw.close('zoom-fade-in');
       		},50);
        };
        updater.showPrompt = function (aniStyles) {
        	var ctitle = "发现新版本"+updater.data.newVersion;
        	var updateLog = updater.data.updateLogs;
        	var isForce = '';
        	
        	if(updater.data.isForceUpdate){
        		isForce = 'true';
        	}
			$.fire(nw,'showPromptBox',{
				title:ctitle,
				updateLog:updateLog,
				ani:aniStyles,
				isForce: isForce
			});
        };
        updater.showProgressBar = function (aniStyles) {
			$.fire(nw,'showProgressBox',{ani:aniStyles});
        };
        updater.update = function (options) {
			$.fire(nw,'UpdateProgress',options);
        };

      	window.addEventListener('updateDownLoad',function(){
      		if(updater.data.updateForce==3){
	            plus.runtime.openURL(updater.data.downloadAddress);
	        }else{
	        	var netType = plus.networkinfo.getCurrentType();
	        	if(netType===4||netType===5||netType===6){
	        		plus.nativeUI.confirm('正在使用流量上网，是否继续更新？', function(event){
	        			if (0==event.index) {
	        				downWgt();
	        			}else{
	        				updater.showPrompt();
	        			}
	        		},'更新',['继续下载','取消下载']);
	        	}else{
	        		downWgt();
	        	}
	        }
   		},false);
   		window.addEventListener('updateCancle',function(){
   			updater.close();
   			if(!updater.data.isForceUpdate) return;
    		if(mui.os.ios){
    			(function showTooOld(){
    				plus.nativeUI.alert('当前版本已不可用,请前往AppStore更新！',function(){
    					plus.runtime.openURL(updater.appStoreUrl);
    					showTooOld();
    				},'版本过旧');
    			})();
    		}else{
    			(function showTooOldA(){
    				plus.nativeUI.alert('当前版本已不可用,请前往应用市场更新！',function(){
    					plus.runtime.openURL(updater.androidUrl);
    					showTooOldA();
    				},'版本过旧');
    			})();
    		}
   		},false);
	}

   	function checkFile(filePath,callback){
   		plus.io.resolveLocalFileSystemURL(filePath, function (entry) {
   			
   			callback && callback(true);
//         	entry.file(function(file){
//				fileMd5(file,function(hash){
//					callback(hash);
//				});
//			},function(err){
//				console.log(err.message,err);
//	    		callback();
//			});
        }, function (err) {
            console.log(err.message,err);
            callback();
        });
   	}
   	var errCount = 0;
	function downWgt(quiet){
		//下个版本 如果更新包存在则不重复下载  用MD5 校验文件；
        updater.showProgressBar();
        var path = '_doc/update/';
        var fileName = updater.data.newVersion+['.wgtu','.wgt','.apk'][updater.data.updateForce];

        var down = function(){
        	var dtask=plus.downloader.createDownload(updater.data.downloadAddress, {
        		filename:path+fileName,timeout:40}, function(d,status){
		        if ( status == 200 ) {
		         
		            updater.update({
		            	downloadedSize:d.downloadedSize,
	                	totalSize:d.totalSize,
	                	tipText:'下载完成，准备安装升级...'
		            });
		           setTimeout(function(){
		            	updater.close();
		            	installWgt(d.filename);
		            },300);
		        } else {
		          
		            if(!quiet){
		            	plus.nativeUI.alert("下载升级文件失败！",function () {
	                    	updater.showPrompt();
	                	});
		            }
		        }
	        });
	        updater.update({tipText:'开始获取资源文件...'});
	        dtask.start();
            var timer = null;
		    dtask.addEventListener("statechanged", function(task,status){
		    	timer = setTimeout(function(){
		    		if(task.state==2){
			    		updater.update({tipText:'正在下载资源文件...'});
						updater.update({
		                	downloadedSize:task.downloadedSize,
		                	totalSize:task.totalSize
		                });
					}
					if(task.state==3){
						var per = parseInt(task.downloadedSize/task.totalSize*100);
		                updater.update({
		                	downloadedSize:task.downloadedSize,
		                	totalSize:task.totalSize
		                });
					}	
					if(task.state==0){
						errCount ++;
						
						if (errCount === 10) {
						    clearTimeout(timer);
							plus.nativeUI.alert("下载升级文件失败！",function () {
                                updater.showPrompt();
                                errCount = 0;
                            });
							dtask.abort();
							dtask = null;
						}
					}
		    	}, 100)
		    	
		    }, false);
        };
        updater.update({tipText:'正在校验本地文件...'});
        checkFile(path+fileName,function(hasFile){
        	if(hasFile){
        		updater.close();
    			installWgt(path+fileName,quiet);
        	}else{
        		removeDir(path,function(){
		        	down();
		        });
        	}
        });
	}
	function installWgt(path,quiet){
        console.log("开始安装升级文件："+path);
	    if(!quiet) plus.nativeUI.showWaiting("安装升级文件...");
        plus.runtime.install(path,{force:true},function(info){
        	if(/\.apk$/.test(path)) return;
            console.log("安装升级文件成功！");
            installSuccess(path);
	        plus.nativeUI.closeWaiting();
	        myStorage.setItem('resver',info.version);
			if(!quiet) plus.nativeUI.alert("应用资源更新完成！",function(){
	           plus.runtime.restart();
	        });
	        
	    },function(e){
	        plus.nativeUI.closeWaiting();
	        console.log("安装升级文件失败["+e.code+"]："+e.message);
	        if(!quiet) plus.nativeUI.alert("安装升级文件失败["+e.code+"]："+e.message);
	    });
	}
	
	function downWgtu(){
		var path = '_doc/update/';
		var fileName = updater.data.newVersion+['.wgtu','.wgt','.apk'][updater.data.updateForce];
		var down = function(){
			var dtask=plus.downloader.createDownload(updater.data.downloadAddress, {
        		filename:path,timeout:40}, function(d,status){
		        if ( status == 200 ) {
		            console.log("下载升级文件成功："+d.filename);
		            installWgtu(d.filename); // 安装wgt包
		        } else {
		            console.log("下载升级文件失败！");
		        }
	        });
	        console.log("开始下载升级文件："+updater.data.downloadAddress);
		    dtask.start();
		}
        removeDir(path,function(){
        	down();
        });
	}
	function installWgtu(path){
        console.log("开始安装升级文件："+path);
        plus.runtime.install(path,{force:true},function(info){
            console.log("安装升级文件成功！");
            installSuccess(path);
	        myStorage.setItem('resver',info.version);
	        $.toast('自动修复成功');
	    },function(e){
	        console.log("安装升级文件失败["+e.code+"]："+e.message);
	    });
	}
	
	function removeDir(path,callback){
		plus.io.resolveLocalFileSystemURL( path, function (entry) {
            entry.removeRecursively();
            callback();
       }, function (error) {
        	callback();
        });
	};
	
	function installSuccess(path) {
        console.log("删除更新包文件："+path);
       	var dir = '_doc/update/';
        plus.io.resolveLocalFileSystemURL( dir, function (entry) {
            console.log("删除更新包文件："+path+" 成功");
            //entry.remove();
            entry.removeRecursively();
        }, function (error) {
            console.log("删除更新包文件："+path+" 失败");
        });
    }
    
    function promptUpdate(data,manual) {
    	updater.data = data;
    	var showPrompt = mui.os.android&&data.updateForce!=0;
    	if(data.updateForce!=0) myStorage.setItem('newVersion',data.newVersion);
		if(showPrompt){
            createUpdateView();
        }else{
        	var autoDownload = app.getSetting('autoUpdateInWifi')&&plus.networkinfo.getCurrentType()===3;
        	 if(data.updateForce===0){
        	 	downWgtu();
        	 }else if(autoDownload){
        	 	downWgt(true);
        	 }
        }
    }

	function checkVersion(callback,manual){
		callback = callback || mui.noop;
		var currVersion = myStorage.getItem('appver');
		
		request.post(updater.checkUrl,{
			appVersion:currVersion,
			system:plus.os.name,
			appid:plus.runtime.appid
		}).then(function(data){
			
//			if (!data) return;
		 	data = formatData(data);
		 	
			if(compare(data.newVersion, currVersion) || true){
				console.log('发现新版本：'+data.newVersion);
				promptUpdate(data,manual);
			}else{
				myStorage.removeItem('newVersion');
				callback(true);
			}
		}).catch(function(err){
			console.error(err.message,err);
			$.toast('连接版本服务器失败');
		});
	}
	function compare(str1, str2) {
		
		if (!str1) return false;
		str1 = str1.split('.');
		str2 = str2.split('.');
		var i = 0;
		do{
			
			if (str1[i] === undefined) {
				return false
			} else if (str2[i] === undefined) {
				return true;
			} else {
				if (Number(str1[i]) > Number(str2[i])) {
					return true;
				} else if (Number(str1[i]) < Number(str2[i])){
					return false;
				}
			}
			i ++;
		} while(i);
		
	}
	var obj = {};
	obj.checkVersion = checkVersion;
   	obj.checkFile = checkFile;
   	
	window.update = obj;
	
})(mui,myStorage,app);
